
package Core.member;

import java.util.Vector;

/**
 *
 * @author Ricardo
 */
public class InterfaceMember {
    //esta clase es encargada de trae los miembros de el vectorMain realizando implicitamente el casting correspondiente
    Vector vectorMain;
    public InterfaceMember(Vector vectorMain) {
        this.vectorMain=vectorMain;
    }
    public Vector getVectorDimension(int dimension){
        Vector vector=null;        
        if(dimension<vectorMain.size()){//osea si el indice de la dimension existe
            vector=(Vector) vectorMain.get(dimension);
        }
        return vector;
    }    
    public MyNodeMember getMyNodeMember(int dimension,int index){
        Vector vector=getVectorDimension(dimension);
        int variableProbar=vector.size();
        MyNodeMember myNodeMember=null;
            if(vector!=null && index<vector.size()){
                myNodeMember=(MyNodeMember) vector.get(index);
            }
        return myNodeMember;
    }
    public int getNumDimension(){//retorna el numero de dimensiones que contiene el vector
        return vectorMain.size();
    }
    public int getNumMember(int dimension){//retorna el numero de miembos de cierta dimension
        if(vectorMain.get(dimension)!=null)
            return ((Vector) vectorMain.get(dimension)).size();
        else
            return 0;
    }
}
