package Core.member;
import org.olap4j.metadata.Member;
import java.util.Vector;

/**
 *
 * @author Ricardo
 */
public class ManagementMembers {
/**Esta es la clase principal de este paquete
 *En este paquete se encuentra el manejo de los miembros que se encuentran en el cubo 
 */
    //Se realiza el manejo de el vector de miembros, cada uno con un padre...
    Vector vectorTree;//es un Vector, que en cada indice tiene un subvector de Members[]
    Vector vectorMain;//es un Vector, que en cada indice tiene un subvector de Vector, que a su vez en cada indice tiene un MyNodeMember
    public ManagementMembers(Vector vectorMembers){ 
        //vectorMembers es un Vector, que en cada indice tiene un subvector de Members[]        
        this.vectorTree =vectorMembers;   
        createVectorMembers();
    }
    private void createVectorMembers() {
        //encargada de Crear el vectorMain
        //vectorMain contiene los miembros pero con un subindice que indica el padre para referenciar y construir el tree
        vectorMain=new Vector();
        MyNodeMember myNodeMember;
        for(int i=0;i<vectorTree.size();i++){
            Member memberVector[]=(Member[]) vectorTree.get(i);
            Vector vector=new Vector();            
            myNodeMember=new MyNodeMember(memberVector[0]);
            vector.add(myNodeMember);                
            vectorMain.add(vector);
        }
    }
    public Vector getVectorMain(){
        return vectorMain;
    }
    public void setVectorMain(Vector vectorMain){
        this.vectorMain=vectorMain;
    }
}
