/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Core.operations;

import Core.member.InterfaceMember;
import Core.member.MyNodeMember;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.olap4j.OlapException;
import org.olap4j.metadata.Member.Type;
import org.olap4j.metadata.Dimension.Type.*;

/**
 *
 * @author Ricardo
 */
public class DeleteMember {
    boolean bandera=true;
    Vector vectorMain;
    InterfaceMember interfaceMember;
    public DeleteMember(Vector vectorMain, int dimension, int member) {
        try {
            this.vectorMain = vectorMain;
            this.interfaceMember = new InterfaceMember(vectorMain);            
            if ((interfaceMember.getMyNodeMember(dimension, member).getMember().getMemberType() != Type.ALL) && 
                    (interfaceMember.getMyNodeMember(dimension, member).getMember().getDimension().getDimensionType()!=org.olap4j.metadata.Dimension.Type.MEASURE)) {
                this.vectorMain = operations(dimension, member);
            } else {
                this.bandera = false;
            }
        } catch (OlapException ex) {
            Logger.getLogger(DeleteMember.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public boolean getBandera() {
       return this.bandera;
    }

    public Vector getVectorMain(){
        return this.vectorMain;
    }

    private Vector operations(int dimension, int member) {
        Vector vector=new Vector();
            //primero copiamos las dimensiones que no tocaremos
            for (int i = 0; i < dimension; i++) {                
                vector.add((Vector) vectorMain.get(i));
            }
            //segundo llenamos el Vector correspondiente a la dimension con los miembros de la izquierda del miembro a eliminar
            Vector vectorAuxiliar2 = new Vector();
            for (int i = 0; i < member; i++) {               
                vectorAuxiliar2.add(interfaceMember.getMyNodeMember(dimension, i));
            }//llenamos el Vector correspondiente a la dimension con los miembros de la derecha del miembro a eliminar
            for (int i = member+1; i < interfaceMember.getNumMember(dimension); i++) {               
                vectorAuxiliar2.add(interfaceMember.getMyNodeMember(dimension, i));
            }
            vector.add(vectorAuxiliar2);
            //tercero llenamos las siguientes dimensiones
                int indice=member;
                int resta=1;
                int fatherPosicion=member;
                int indexPosicion=0;
                for(int i=dimension+1;i<interfaceMember.getNumDimension();i++){
                    Vector vectorAuxiliar3=new Vector();
                    for(int var=0;var<interfaceMember.getNumMember(i);var++){
                         if(interfaceMember.getMyNodeMember(i, var).getFather()==fatherPosicion){
                            fatherPosicion=var;
                            break;
                         }//asi garantizamo que se coja al primer padre
                    }
                    
                    for(int var=0;var<interfaceMember.getNumMember(i);var++){
                         if(interfaceMember.getMyNodeMember(i, var).getFather()==indice){
                            indexPosicion=var;                            
                         }//asi garantizamo que se coja al ultimo indice
                    }
                    indice=indexPosicion;//indice tiene ahora el ultimo miembro a eliminar de esta dimension (dimension +1)
                    System.out.println("Este es fatherPosicion: "+fatherPosicion+", y este es el indexPosicion: "+indice);
                    for (int j = 0; j < fatherPosicion; j++) {
                        vectorAuxiliar3.add(interfaceMember.getMyNodeMember(i, j));
                    }
                    //vectorAuxiliar3.add(interfaceMember.getMyNodeMember(i, fatherPosicion));
                    for (int j = indice+1; j < interfaceMember.getNumMember(i); j++) {
                        MyNodeMember myNodeMember=(MyNodeMember) interfaceMember.getMyNodeMember(i, j).clone();                        
                        int padre=myNodeMember.getFather()-resta;
                        System.out.println("Este es el valor del padre: "+padre);
                        myNodeMember.setFather(padre);
                        vectorAuxiliar3.add(myNodeMember);
                    }                    
                    resta=indice-fatherPosicion+1;
                    vector.add(vectorAuxiliar3);
                }                                    
        
        return vector;
    }
}
