package Core.operations;
import java.util.Vector;
import Core.member.*;



import java.util.logging.Level;
import java.util.logging.Logger;
import org.olap4j.OlapException;
import org.olap4j.metadata.Member;
import org.olap4j.metadata.NamedList;
/**
 *
 * @author Ricardo
 */
public class DrillDown_RollUp {
    private RollUp rollUp;
    Vector vectorMain;
    boolean bandera=true;
    public DrillDown_RollUp(Vector vectorMain, int dimension, int member) {
        this.vectorMain=vectorMain;
        InterfaceMember interfaceMember=new InterfaceMember(vectorMain);
        verificate(interfaceMember,dimension,member);
    }

    private boolean validatorChild(Member member, Member member0) {
        //si es child entonces es true
        boolean retorno=false;
        try {            
            NamedList<? extends Member> memberList = member.getChildMembers();            
            if(memberList.contains(member0))
            retorno=true;
        } catch (OlapException ex) {
            Logger.getLogger(DrillDown_RollUp.class.getName()).log(Level.SEVERE, null, ex);
        }
          return retorno;
    }

    private void verificate(InterfaceMember interfaceMember, int dimension, int member) {
        //verifica si la operacion a realizar es DrillDown o RollUp
        MyNodeMember myNodeMember=interfaceMember.getMyNodeMember(dimension, member);
        MyNodeMember myNodeMember1=interfaceMember.getMyNodeMember(dimension, member+1);//puede ser que no exista
        //en este caso quiere decir que se va a hacer un DrillDown
        if(myNodeMember1!=null && validatorChildAncestor(myNodeMember.getMember(),myNodeMember1.getMember())){
        //si es true entonces es child, entonces haga 
            System.out.println("Clase DrillDown_RollUp, si es hijo vayase a RollUp");
            RollUp rollUp1=new RollUp(vectorMain,dimension,member);
            if(rollUp1.getVectorMain()!=null)
                this.vectorMain=rollUp1.getVectorMain();
        }
        else{
        // no es hijo, haga DrillDown
            System.out.println("Clase DrillDown_RollUp, no es hijo vayase a DrillDown");
            DrillDown drillDown=new DrillDown(vectorMain,dimension,member);
            this.bandera=drillDown.getBandera();            
            this.vectorMain=drillDown.getVectorMain();
        }         
    }    
    public boolean getBandera(){
        return this.bandera;
    }    
    public Vector getVectorMain() {
        return this.vectorMain;
    }    
//    public Vector getVectorMain() {
//
//    }

    //Esta funcion es solo de prueba, lo que hace es revisar si un member es ansestro de otro, ya sea padre, abuelo..
    public boolean validatorChildAncestor(Member member,Member member0){
        boolean retorno = false;
        try {
            NamedList<? extends Member> memberList = member.getChildMembers();
            if(memberList.contains(member0))
                retorno=true;                
            else{
                for(int i=0;i<memberList.size();i++){
                    retorno=validatorChildAncestor(memberList.get(i), member0);
                    if(retorno==true)
                        break;                }
            }
        } catch (OlapException ex) {
            Logger.getLogger(DrillDown_RollUp.class.getName()).log(Level.SEVERE, null, ex);
        }
        return retorno;        
    }        
}
