/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Core.operations;

import java.util.Vector;
import Core.member.InterfaceMember;
import Core.member.MyNodeMember;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.olap4j.OlapException;
import org.olap4j.metadata.Member;
import org.olap4j.metadata.NamedList;


/**
 *
 * @author Ricardo
 */
public class RollUp {
    Vector vectorMain;
    InterfaceMember interfaceMember;
    public RollUp(Vector vectorMain, int dimension, int member) {
        this.vectorMain=vectorMain;
        this.interfaceMember=new InterfaceMember(vectorMain);
        this.vectorMain=operations(dimension,member);
    }

    private Vector operations(int dimension, int member) {
        Vector pila=new Vector();
        Vector vector=new Vector();
            //primero copiamos las dimensiones que no tocaremos
            for (int i = 0; i < dimension; i++) {                
                vector.add((Vector) vectorMain.get(i));
            }
            //segundo llenamos el Vector correspondiente a la dimension con los miembros de la izquierda
            Vector vectorAuxiliar2 = new Vector();
            for (int i = 0; i < member; i++) {               
                vectorAuxiliar2.add(interfaceMember.getMyNodeMember(dimension, i));
            }
            
            //////////////Aqui empieza lo bueno            
            int indice=member;
            pila.add(interfaceMember.getMyNodeMember(dimension, member));
            while(pila.size()>0) {//osea mientras la pila tenga elementos
            indice++;
               if(interfaceMember.getMyNodeMember(dimension,indice)!=null) {
                   Member member1=((MyNodeMember) pila.get(pila.size()-1)).getMember();                   
                   Member member2=interfaceMember.getMyNodeMember(dimension, indice).getMember();
                   if(validatorChildAncestor(member1,member2)){//osea si member2 es child de member1
                       pila.add(interfaceMember.getMyNodeMember(dimension, indice));
                   }
                   else{
                       indice--;//esto es para mantener el indice en el siguiente ciclo
                       pila.remove(pila.size()-1);
                   }
               }
               else{
                    indice--;
                    break;                                        
               }
            }
            //cuando sale del ciclo, el indice tomara la posicion de el último miembro a "eliminar"
            //por eso si el indice tiene la mimsma posicion de member no se hace nada       
            if(indice>member){//osea si tiene hijos para hacer Roll Up
                vectorAuxiliar2.add(interfaceMember.getMyNodeMember(dimension, member));
                int resta=indice-member;//resta contendra el numero de miembros a eliminar
                for(int i=indice+1;i<interfaceMember.getNumMember(dimension);i++){
                    vectorAuxiliar2.add(interfaceMember.getMyNodeMember(dimension, i));                    
                }
                vector.add(vectorAuxiliar2);
                int fatherPosicion=member;
                int indexPosicion=0;
                for(int i=dimension+1;i<interfaceMember.getNumDimension();i++){
                    Vector vectorAuxiliar3=new Vector();
                    for(int var=0;var<interfaceMember.getNumMember(i);var++){
                         if(interfaceMember.getMyNodeMember(i, var).getFather()==fatherPosicion){
                            fatherPosicion=var;
                            break;
                         }//asi garantizamo que se coja al primer padre
                    }
                    
                    for(int var=0;var<interfaceMember.getNumMember(i);var++){
                         if(interfaceMember.getMyNodeMember(i, var).getFather()==indice){
                            indexPosicion=var;                            
                         }//asi garantizamo que se coja al ultimo indice
                    }
                    indice=indexPosicion;
                    System.out.println("Este es fatherPosicion: "+fatherPosicion+", y este es el indexPosicion: "+indice);
                    for (int j = 0; j < fatherPosicion; j++) {
                        vectorAuxiliar3.add(interfaceMember.getMyNodeMember(i, j));
                    }
                    vectorAuxiliar3.add(interfaceMember.getMyNodeMember(i, fatherPosicion));
                    for (int j = indice+1; j < interfaceMember.getNumMember(i); j++) {
                        MyNodeMember myNodeMember=(MyNodeMember) interfaceMember.getMyNodeMember(i, j).clone();                        
                        int padre=myNodeMember.getFather()-resta;
                        myNodeMember.setFather(padre);
                        vectorAuxiliar3.add(myNodeMember);
                    }                    
                    resta=indice-fatherPosicion;                                        
                    vector.add(vectorAuxiliar3);
                }                                
            }
            else{
                // No haga nada, "tranquilamente" lo podemos borrar
                vector=null;
            }                           
        return vector;
    }

    public boolean validatorChildAncestor(Member member,Member member0){
        boolean retorno = false;
        try {
            NamedList<? extends Member> memberList = member.getChildMembers();
            if(memberList.contains(member0))
                retorno=true;                
            else{
                for(int i=0;i<memberList.size();i++){
                    retorno=validatorChildAncestor(memberList.get(i), member0);
                    if(retorno==true)
                        break;                }
            }
        } catch (OlapException ex) {
            Logger.getLogger(DrillDown_RollUp.class.getName()).log(Level.SEVERE, null, ex);
        }
        return retorno;        
    }
    Vector getVectorMain() {
        return this.vectorMain;
    }    
}