package Core.queryMDX;

import Core.tree.MyDefaultMutableTreeNode;
import java.util.Vector;
import javax.swing.tree.DefaultTreeModel;

/**
 *
 * @author Ricardo
 */
public class QueryAxis {    
    /////////////////
    Vector pila,cadenasDeUnion,ultimate;
    DefaultTreeModel modelo;
     public QueryAxis(DefaultTreeModel modelo){
        this.modelo=modelo;
        createQuery();
    }
     private void createQuery() {        
        pila=new Vector();
        ultimate=new Vector();
        initial((MyDefaultMutableTreeNode) modelo.getRoot());
    }     
     private void initial(MyDefaultMutableTreeNode myDefaultMutableTreeNode) {
        if(myDefaultMutableTreeNode.getChildCount()>0)//si tiene hijos el nodo inicial (la raiz)
            for(int i=0;i<myDefaultMutableTreeNode.getChildCount();i++){
                cadenasDeUnion=new Vector(); 
                funcionR((MyDefaultMutableTreeNode)myDefaultMutableTreeNode.getChildAt(i));
                ultimate.add(recorrerVectorDeUniones(0));
                cadenasDeUnion=null;
            }
    }
     private void funcionR(MyDefaultMutableTreeNode nodito){
         //encargado de generar cadenas de Crossjoin en el vector cadenasDeUnion
        if(nodito.getChildCount()>0){//si tiene hijos apilelos en la pila
            for(int i=0;i<nodito.getChildCount();i++){
                pila.add(nodito.getChildAt(i));
            }            
            if(!pila.isEmpty()){
                MyDefaultMutableTreeNode recursiv=(MyDefaultMutableTreeNode) pila.remove(pila.size()-1);
                funcionR(recursiv);
            }                            
        }
        else{//si no tiene hijos
            //TreeNode ruta[]=nodito.getPath();
            MiClaseVector vectorNodos=new MiClaseVector(nodito.getPath());
            cadenasDeUnion.add(generarConsulta2(vectorNodos,0));           
            if(!pila.isEmpty()){
                MyDefaultMutableTreeNode node=(MyDefaultMutableTreeNode) pila.remove(pila.size()-1);
                funcionR(node);
            }
             
        }        
    }
     private String generarConsulta2(MiClaseVector vectorNodos,int indice){
        if(vectorNodos.length()>indice+1){            
            return crossjoin("{"+vectorNodos.getMiembro(indice).getUniqueName()+"}",generarConsulta2(vectorNodos, indice+1));
        }
        else
            return "{"+vectorNodos.getMiembro(indice).getUniqueName()+"}";                           
    }
     private String union(String izquierda,String derecha){
            String consulta="Union("+izquierda+","+derecha+")";
            return consulta;                
    }
     private String crossjoin(String consultaPadre,String consultaHijo){
            String consulta="Crossjoin("+consultaPadre+","+consultaHijo+")";
            return consulta;
    }
     private String recorrerVectorDeUniones(int indice){          
        if(cadenasDeUnion.size()>indice+1){
                String cadenaRetornar=union((String)cadenasDeUnion.get(indice),recorrerVectorDeUniones(indice+1));
                return cadenaRetornar;
        }
        else{
            String cadenaRetornar=(String) cadenasDeUnion.get(indice);
            //System.out.println(cadenaRetornar);
            return cadenaRetornar;
        }
    }
     public String getQueryAxis(){
        return recorrerVectorUltimate(0);
     }
     public void setModelo(DefaultTreeModel modelo){
        this.modelo=modelo;
     }
     private String recorrerVectorUltimate(int indice){
        if(ultimate.size()>indice+1){
                String cadenaRetornar=union((String)ultimate.get(indice),recorrerVectorUltimate(indice+1));
              //  System.out.println(cadenaRetornar);
                return cadenaRetornar;
        }
        else{
            String cadenaRetornar=(String) ultimate.get(indice);
            //System.out.println(cadenaRetornar);
            return cadenaRetornar;
        }         
     }
}