package Core.tree;
import org.olap4j.*;
import org.olap4j.metadata.*;
import javax.swing.tree.*;

/**
 *
 * @author Ricardo
 */
public class MyDefaultMutableTreeNode extends DefaultMutableTreeNode{
    Member miembro;
    int lugarJerarquia=0;
    int father=0;
    public MyDefaultMutableTreeNode(Member miembro){
        this.miembro=miembro;
    }
    public String getName(){
        return miembro.getName();
    }    
    public String getUniqueName(){
        return miembro.getUniqueName();
    }    
    public Member getMiembro(){
        return this.miembro;
    }
    public int getLugarJerarquia(){
        return lugarJerarquia;
    }
    public int getFather(){
        return father;
    }
    public void setLugarJerarquia(int lugarJerarquia){
        this.lugarJerarquia=lugarJerarquia;
    }
    public void setFather(int father){
        this.father=father;
    }    
}
