/*
 * Account.java
 *
 * Created on 11 de diciembre de 2008, 11:57
 */

package WorkSpace.Account;

import WorkSpace.Account.MyCellRendererUser;
import WorkSpace.CubeConfiguration.ExitAlert;
import WorkSpace.MainApp;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import org.noos.xing.mydoggy.ToolWindow;

/**
 *
 * @author  Alexander
 */
public class Account extends javax.swing.JPanel {
    Connection con; String username;
      PreparedStatement ps;
       ResultSet rs;
       ToolWindow userTool;
         ImageIcon imagen;
        NewAccount account;
    /** Creates new form Account */
  public Account(Connection con, String username, NewAccount account) {
        this.con=con;
        this.username=username;        
        this.account=account;        
        initComponents();          
        this.lst_user.setCellRenderer(new MyCellRendererUser());
        getUsers();
    }

    public void setToolWindow(ToolWindow userTool) {
        this.userTool=userTool;
    }

    private void delUser() {
        Statement sql;
        String sqlText;
        if(!this.lst_user.isSelectionEmpty())
        {
            try
            {   sql = con.createStatement(); //create a statement that we can use later
                sqlText = "DROP ROLE "+this.lst_user.getSelectedValue().toString();               
                sql.executeUpdate(sqlText);
                sql.close();
                ps = con.prepareStatement("DELETE FROM xml WHERE rolname=?");                   
                ps.setString(1,this.lst_user.getSelectedValue().toString());                   
                ps.executeUpdate();
                ps = con.prepareStatement("DELETE FROM cube WHERE rolname=?");                   
                ps.setString(1,this.lst_user.getSelectedValue().toString());                   
                ps.executeUpdate();
                ps = con.prepareStatement("DELETE FROM userolap WHERE rolname=?");                   
                ps.setString(1,this.lst_user.getSelectedValue().toString());                   
                ps.executeUpdate();                
            }
            catch (Exception e)
            {
              e.printStackTrace();
            }
            getUsers();
        }
    }

    private void getUsers() {
       DefaultListModel  listmodel= new DefaultListModel();      
       try{  ps = con.prepareStatement("select * from userolap");                                               
            rs = ps.executeQuery();                  
            while (rs.next())
            {       if(!rs.getString("rolname").equalsIgnoreCase(username))
                      listmodel.addElement(rs.getString("rolname"));                             
            }                     


        }                      
         catch (Exception e) {}

      this.lst_user.setModel(listmodel); 
   }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        lst_user = new javax.swing.JList();
        btn_edit = new javax.swing.JButton();
        btn_del = new javax.swing.JButton();
        lbl_message = new javax.swing.JLabel();
        btn_update = new javax.swing.JButton();
        add_user = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();

        setName("Form"); // NOI18N
        setPreferredSize(new java.awt.Dimension(320, 0));

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(WorkSpace.MainApp.class).getContext().getResourceMap(Account.class);
        lst_user.setFont(resourceMap.getFont("lst_user.font")); // NOI18N
        lst_user.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        lst_user.setToolTipText(resourceMap.getString("lst_user.toolTipText")); // NOI18N
        lst_user.setName("lst_user"); // NOI18N
        lst_user.setPreferredSize(null);
        jScrollPane1.setViewportView(lst_user);

        btn_edit.setIcon(resourceMap.getIcon("btn_edit.icon")); // NOI18N
        btn_edit.setText(resourceMap.getString("btn_edit.text")); // NOI18N
        btn_edit.setToolTipText(resourceMap.getString("btn_edit.toolTipText")); // NOI18N
        btn_edit.setName("btn_edit"); // NOI18N
        btn_edit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_editActionPerformed(evt);
            }
        });

        btn_del.setIcon(resourceMap.getIcon("btn_del.icon")); // NOI18N
        btn_del.setToolTipText(resourceMap.getString("btn_del.toolTipText")); // NOI18N
        btn_del.setLabel(resourceMap.getString("btn_del.label")); // NOI18N
        btn_del.setName("btn_del"); // NOI18N
        btn_del.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_delActionPerformed(evt);
            }
        });

        lbl_message.setText(resourceMap.getString("lbl_message.text")); // NOI18N
        lbl_message.setName("lbl_message"); // NOI18N

        btn_update.setIcon(resourceMap.getIcon("btn_update.icon")); // NOI18N
        btn_update.setText(resourceMap.getString("btn_update.text")); // NOI18N
        btn_update.setToolTipText(resourceMap.getString("btn_update.toolTipText")); // NOI18N
        btn_update.setName("btn_update"); // NOI18N
        btn_update.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_updateActionPerformed(evt);
            }
        });

        add_user.setIcon(resourceMap.getIcon("add_user.icon")); // NOI18N
        add_user.setText(resourceMap.getString("add_user.text")); // NOI18N
        add_user.setToolTipText(resourceMap.getString("add_user.toolTipText")); // NOI18N
        add_user.setName("add_user"); // NOI18N
        add_user.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                add_userActionPerformed(evt);
            }
        });

        jLabel1.setFont(resourceMap.getFont("jLabel1.font")); // NOI18N
        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jLabel1.setName("jLabel1"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(56, 56, 56)
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 101, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                .addGap(4, 4, 4)
                                .addComponent(btn_update, javax.swing.GroupLayout.PREFERRED_SIZE, 46, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(add_user, javax.swing.GroupLayout.PREFERRED_SIZE, 39, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(btn_edit, javax.swing.GroupLayout.PREFERRED_SIZE, 39, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(btn_del, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(lbl_message, javax.swing.GroupLayout.PREFERRED_SIZE, 186, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 216, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(5, 5, 5)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 269, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(11, 11, 11)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btn_del, javax.swing.GroupLayout.PREFERRED_SIZE, 41, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btn_edit)
                    .addComponent(add_user, javax.swing.GroupLayout.PREFERRED_SIZE, 41, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btn_update, javax.swing.GroupLayout.PREFERRED_SIZE, 41, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lbl_message, javax.swing.GroupLayout.PREFERRED_SIZE, 66, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(190, Short.MAX_VALUE))
        );

        jLabel1.getAccessibleContext().setAccessibleParent(lst_user);
    }// </editor-fold>//GEN-END:initComponents

    private void btn_delActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_delActionPerformed
        // TODO add your handling code here:
        if(!this.lst_user.isSelectionEmpty())
        {
            JFrame mainFrame = MainApp.getApplication().getMainFrame();
           ExitAlert demoDialogo4 = new ExitAlert(mainFrame,true,1,this.lst_user.getSelectedValue().toString());
           demoDialogo4.setLocationRelativeTo(mainFrame);
           MainApp.getApplication().show(demoDialogo4);         
             if(demoDialogo4.getReturnStatus()==1)
                delUser(); 
        }else{
              imagen = createImageIcon("resources/infouser.png");
              this.lbl_message.setIcon(imagen);
              this.lbl_message.setText("First Select a User");
        }
       
    }//GEN-LAST:event_btn_delActionPerformed

    private void btn_updateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_updateActionPerformed
        // TODO add your handling code here:
          this.lbl_message.setIcon(null);
          this.lbl_message.setText("");
          getUsers();
    }//GEN-LAST:event_btn_updateActionPerformed

    private void add_userActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_add_userActionPerformed
        // TODO add your handling code here:     
        account.setNewUser(true);
        (userTool.getToolWindowTabs())[1].setSelected(true);
        userTool.setActive(true);
        
    }//GEN-LAST:event_add_userActionPerformed

    private void btn_editActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_editActionPerformed
        // TODO add your handling code here:
        if(!this.lst_user.isSelectionEmpty())
        {   account.setNewUser(false);
            account.setUpdateUser(this.lst_user.getSelectedValue().toString());
            this.lbl_message.setIcon(null);
            this.lbl_message.setText("");
            (userTool.getToolWindowTabs())[1].setSelected(true);
            userTool.setActive(true);
        }
        else{
             imagen = createImageIcon("resources/infouser.png");
              this.lbl_message.setIcon(imagen);
              this.lbl_message.setText("Select a User");
        }
    }//GEN-LAST:event_btn_editActionPerformed
   private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = MainApp.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton add_user;
    private javax.swing.JButton btn_del;
    private javax.swing.JButton btn_edit;
    private javax.swing.JButton btn_update;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel lbl_message;
    private javax.swing.JList lst_user;
    // End of variables declaration//GEN-END:variables
    
}
