

package WorkSpace.CubeConfiguration;

import java.awt.*;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DragGestureRecognizer;
import java.awt.dnd.DragSource;
import java.awt.dnd.DropTarget;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.*;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;

public class CheckBoxes extends JPanel
                          implements ItemListener {
  
      JCheckBox aux;
      Vector campos;
      JPanel checkPanel;
      JTree tre_consulta;
      String title;
     
    public CheckBoxes(Vector campos,JTree tre_consulta,String title,DND dndListener) {
        super(new BorderLayout());
        this.tre_consulta=tre_consulta;
        this.title=title;
        super.setName(title);
        this.setBackground(Color.LIGHT_GRAY);
        this.setSize(100, 200);
        this.campos=campos;
        checkPanel = new JPanel(new GridLayout(campos.size(), 1));
        checkPanel.setBackground(Color.LIGHT_GRAY);
        DragSource dragSource = new DragSource();
         for(int i=0;i<campos.size();i++)
        {    aux = new JCheckBox(campos.get(i).toString());
             aux.setFont(new Font("arial",Font.PLAIN,9));
             aux.setName(title+","+campos.get(i).toString());
             aux.setBackground(Color.LIGHT_GRAY);
             aux.setSelected(false);
             aux.addItemListener(this);
             checkPanel.add(aux);
             DropTarget dropTarget1 = new DropTarget(aux, DnDConstants.ACTION_MOVE, dndListener);
             DragGestureRecognizer dragRecognizer1 = dragSource.createDefaultDragGestureRecognizer(aux, DnDConstants.ACTION_MOVE, dndListener);
        }
        add(checkPanel, BorderLayout.LINE_START);
      
        
       
        
    }
     public CheckBoxes(){}
    /** Listens to the check boxes. */
    public void itemStateChanged(ItemEvent e) {
       int i;
       String name="",name1="";
       DefaultTreeModel modelo =(DefaultTreeModel)tre_consulta.getModel();
       DefaultMutableTreeNode query=(DefaultMutableTreeNode)modelo.getChild(modelo.getRoot(),0);
       //.out.println("Numero"+query.getChildCount());
       JCheckBox source = (JCheckBox)e.getItemSelectable();
      name1=title+"."+source.getText();
       //Now that we know which button was pushed, find out
        //whether it was selected or deselected.
        if (e.getStateChange() == ItemEvent.DESELECTED) {
            for(i=0;i<query.getChildCount();i++)
               {name =query.getChildAt(i).toString();                 
                name1.trim();
                name.trim();
                if(name1.compareTo(name)==0)
                   {  query.remove(i); 
                      i=query.getChildCount();
                      tre_consulta.updateUI();
                   }
              }
        }
        else   if (e.getStateChange() == ItemEvent.SELECTED){
                     DefaultMutableTreeNode childfrom = new DefaultMutableTreeNode(title+"."+source.getText());
                       modelo.insertNodeInto(childfrom,query,query.getChildCount());
                       tre_consulta.scrollPathToVisible(new TreePath(childfrom.getPath()));

                }
                
    }
    



} 