/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package WorkSpace.CubeConfiguration;

import WorkSpace.MainApp;
import java.awt.Component;
import javax.swing.ImageIcon;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
/**
 *
 * @author Alexander
 */
public class DimensionCellRenderer extends DefaultTreeCellRenderer{		
		public DimensionCellRenderer() {
    		super();
    	}
    @Override
        public Component getTreeCellRendererComponent(JTree tree, Object value,
                boolean isSelected, boolean expanded,
                boolean leaf, int row, boolean hasFocus) {
             ImageIcon dimension =createImageIcon("resources/rubik.jpg"); 
             ImageIcon nivel =createImageIcon("resources/nivel.gif"); 
             ImageIcon jerarquia =createImageIcon("resources/hierarchy.png"); 
            
            String  stringValue = tree.convertValueToText(value, isSelected,
                    expanded, leaf, row, hasFocus);
               	this.hasFocus = hasFocus;
        	setText(stringValue);
        	if(isSelected)
        	    setForeground(getTextSelectionColor());
        	else
        	    setForeground(getTextNonSelectionColor());
        	
        	if (!tree.isEnabled()) {
        	    setEnabled(false);
        	}
        	else {
        	    setEnabled(true);
        	}
	        if(((DefaultMutableTreeNode)value).getLevel()==1)    		
                    setIcon(dimension);
                    else
                         if(((DefaultMutableTreeNode)value).getLevel()==2)    		
                             setIcon(jerarquia);
                         else
                                setIcon(nivel);
              setComponentOrientation(tree.getComponentOrientation());        
        	selected = isSelected;

        	return this;
            }
    private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = MainApp.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }
}
