
package WorkSpace.CubeConfiguration;

import Core.CubeConfiguration.*;
import javax.swing.JInternalFrame;

import java.awt.event.*;
import java.awt.*;
import javax.swing.ImageIcon;
import javax.swing.event.InternalFrameEvent;
import javax.swing.event.InternalFrameListener;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;

public class MyInternalFrame extends JInternalFrame implements InternalFrameListener{
      JTree tre_consulta;
      String a="";
      DND dndListener;
      public MyInternalFrame(String a,int num, int x,int y,JTree tre_consulta,DND dndListener) {
         super(a,
          false, //resizable
          true, //closable
          false, //maximizable
          false);//iconifiable
        this.a=a;       
        this.dndListener=dndListener;
        super.setName(a);       
        super.setBackground(Color.LIGHT_GRAY);
         this.tre_consulta=tre_consulta;
         if (num>4)
         setSize(120,(num+3)*28);
         else{
            switch(num){
                case 1:setSize(120,60);break;
                case 2:setSize(120,120);break;
                case 3:setSize(120,140);break;
                case 4:setSize(120,170);break;           
            
            }
         }         
         ImageIcon icon = createImageIcon("../resources/icont.jpg","starcube");
         super.setFrameIcon(icon);
         //Set the window's location.
         setLocation(160*x,y*24);
         setLayout(new BorderLayout());
         this.addInternalFrameListener(this);
}
  public ImageIcon createImageIcon(String path,String description) {
    java.net.URL imgURL = getClass().getResource(path);
    if (imgURL != null) {
        return new ImageIcon(imgURL, description);
    } else {
        System.err.println("Couldn't find file: " + path);
        return null;
    }
  }

    public void internalFrameOpened(InternalFrameEvent e) {
        
    }

    public void internalFrameClosed(InternalFrameEvent e) {
       int i,j;
       String name;
       DefaultTreeModel modelo =(DefaultTreeModel)tre_consulta.getModel();
       DefaultMutableTreeNode query=(DefaultMutableTreeNode)modelo.getChild(modelo.getRoot(),1);      
       for(i=0;i<query.getChildCount();i++)
       {
           if(query.getChildAt(i).toString().trim().equalsIgnoreCase(title))
           {    tre_consulta.setSelectionPath(new TreePath(query.getPath())); 
                query.remove(i);  
               break;
           }
       }
           
      DefaultMutableTreeNode query1=(DefaultMutableTreeNode)modelo.getChild(modelo.getRoot(),0);
      j=query1.getChildCount();
       for(i=0;i<j;i++)
       {   name=getNameTable(query1.getChildAt(i).toString());
           if(name.equalsIgnoreCase(title))
           {query1.remove(i);i=i-1;j--;}
               
       }
      tre_consulta.updateUI();
      tre_consulta.setSelectionPath(new TreePath(query1.getPath()));      
      this.dndListener.delJoin(a);    
      
    }

    public void internalFrameIconified(InternalFrameEvent e) {
       this.dndListener.paint();
    }

    public void internalFrameDeiconified(InternalFrameEvent e) {
      this.dndListener.paint();
    }

    public void internalFrameActivated(InternalFrameEvent e) {    
       this.dndListener.paint();
    }

    public void internalFrameDeactivated(InternalFrameEvent e) {
    this.dndListener.paint();
    }

    public void internalFrameClosing(InternalFrameEvent e) {
          this.dndListener.paint();
     }
    public String    getNameTable(String name){
        String aux ="";
            for(int i=0;i<name.length();i++){
               if(name.charAt(i)=='.')
                   break;
                aux=aux+""+name.charAt(i);
           }        
        return aux;
    }  
}
