/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package WorkSpace.CubeConfiguration;

import Core.CubeConfiguration.*;
import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Shape;
import java.awt.geom.Ellipse2D;
import java.awt.geom.QuadCurve2D;
import java.util.Vector;
import javax.swing.JDesktopPane;
import javax.swing.JTree;


/**
 *
 * @author Alexander
 */
public class MyJDesktopPane extends JDesktopPane {
   QuadCurve2D q = new QuadCurve2D.Float();
    DND dndListener;
    Vector joins;
    int band=0;
    public MyJDesktopPane(DND dndListener,JTree tre_consulta) {
        this.dndListener=dndListener;
        this.dndListener=new DND(this,tre_consulta);
        tre_consulta.addMouseListener(new MyTreeMouseListener(tre_consulta,this));
         setBackground(new java.awt.Color(190, 230, 250));
    }

    @Override
     protected synchronized void paintComponent(Graphics g ) {    
        joins=this.dndListener.getJoins();
        Graphics2D g1 = (Graphics2D) this.getGraphics();         
        Component[] com=this.getComponents();
        int num=this.getComponentCount();
        int x1,y1 = 0,x2,y2 = 0;
        int auxx1 = 0,auxx2 = 0,auxx3 = 0,auxx4 = 0;
        int auxy1 = 0,auxy2 = 0;
        for(int i=0;i<joins.size();i++)
         {    Conexion con=(Conexion)joins.elementAt(i);
              for(int j=0;j<num;j++)                          
                { if(con.getFromTable().equalsIgnoreCase(com[j].getName()))
                  {auxx1=com[j].getLocation().x; auxy1=com[j].getLocation().y; }
                  if(con.getToTable().equalsIgnoreCase(com[j].getName()))
                  {auxx3=com[j].getLocation().x; auxy2=com[j].getLocation().y;}
                }
                auxx2=auxx1+120;
                auxx4=auxx3+120;
                if(Math.abs(auxx4-auxx1)<Math.abs(auxx3-auxx2)){
                        x1=auxx1;
                        x2=auxx4;
                }
                else{
                    x1=auxx2;
                    x2=auxx3;
                }
                y1=auxy1+con.getFromY();
                y2=auxy2+con.getToY();
                g1.setColor(new Color(112,181,250));
                g1.setStroke(new ShapeStroke(
			new Shape[] {
				new Ellipse2D.Float(0, 0, 6, 6),
				new Ellipse2D.Float(0, 0, 6, 6)
			},15.0f)
	);   
         q.setCurve(x1, y1, x1,y2, x2, y2);
        g1.draw(q);     
      }
      this.repaint(0, 0,3,3);
      this.repaint(70,0,2,2);     
      this.repaint(70, 900,2,2); 
    }
    
    public  DND getDND(){
        return  this.dndListener;
    }

}
