package WorkSpace.CubeConfiguration;


import Core.CubeConfiguration.*;
import WorkSpace.CubeConfiguration.Table;
import WorkSpace.CubeConfiguration.Table;
import WorkSpace.CubeConfiguration.TableAlert;
import WorkSpace.MainApp;
import java.awt.Component;
import java.awt.Container;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DropTarget;
import java.awt.dnd.DropTargetDragEvent;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.dnd.DropTargetEvent;
import java.awt.dnd.DropTargetListener;
import java.io.IOException;
import java.sql.Connection;
import javax.swing.JFrame;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;



public class PanelDropTarget implements DropTargetListener{
    String tablename=null;
    Connection connection=null;
    int medida=0;
    int med=0;
    int cont=1;
    int x=0;
    int y=0;
    Point n1,n2;
    JTree tre_consulta;
    DND dndListener;
    public TableAlert demoDialogo2;
  public PanelDropTarget(MyJDesktopPane pane,Connection connection,JTree tre_consulta) {
    this.pane = pane;    
    this.dndListener=pane.getDND();
    this.tre_consulta=tre_consulta;
    this.connection=connection;
    dropTarget = new DropTarget(pane, DnDConstants.ACTION_COPY,
        this, true, null);
    
    }

        
  // Implementation of the DropTargetListener interface
  public void dragEnter(DropTargetDragEvent dtde) {
      // Get the type of object being transferred and determine
    // whether it is appropriate.
    n1=dtde.getLocation();
    checkTransferType(dtde);
    // Accept or reject the drag.
    acceptOrRejectDrag(dtde);
  }

  public void dragExit(DropTargetEvent dte) {
  }

  public void dragOver(DropTargetDragEvent dtde) {   
        // Accept or reject the drag
     n2=dtde.getLocation();
     Graphics g = pane.getGraphics();    
    // g.setColor(Color.BLACK);    
     acceptOrRejectDrag(dtde);
  }

  public void dropActionChanged(DropTargetDragEvent dtde) {
    acceptOrRejectDrag(dtde);
  }

  public void drop(DropTargetDropEvent dtde) {
      Object target = dtde.getSource();
     Container com=(Container)((DropTarget)target).getComponent();
     this.dndListener.setFromNull();
           try {
                    Transferable transferable = dtde.getTransferable();                   
                    // we accept only Strings      
                    if (transferable.isDataFlavorSupported (DataFlavor.stringFlavor)){        
                        dtde.acceptDrop(DnDConstants.ACTION_MOVE);
                        tablename = (String)transferable.getTransferData ( DataFlavor.stringFlavor);           
                         dtde.getDropTargetContext().dropComplete(true);
                       } 
                        else{
                            dtde.rejectDrop();
                        }
                    }
                    catch (IOException exception) {
                        exception.printStackTrace();
                        System.err.println( "Exception" + exception.getMessage());
                        dtde.rejectDrop();
                    } 
                    catch (UnsupportedFlavorException ufException ) {
                      ufException.printStackTrace();
                      System.err.println( "Exception" + ufException.getMessage());
                      dtde.rejectDrop();
                    }
                    newTable(tablename);
      
  }
 
  // Internal methods start here

  protected boolean acceptOrRejectDrag(DropTargetDragEvent dtde) {
    int dropAction = dtde.getDropAction();
    int sourceActions = dtde.getSourceActions();
    boolean acceptedDrag = false;
    // Reject if the object being transferred
    // or the operations available are not acceptable.
    if (!acceptableType
        || (sourceActions & DnDConstants.ACTION_COPY_OR_MOVE) == 0) {    
      dtde.rejectDrag();
    } else if ((dropAction & DnDConstants.ACTION_COPY_OR_MOVE) == 0) {
      // Not offering copy or move - suggest a copy     
      dtde.acceptDrag(DnDConstants.ACTION_COPY);
      acceptedDrag = true;
    } else {
      // Offering an acceptable operation: accept    
      dtde.acceptDrag(dropAction);
      acceptedDrag = true;
    }
      return acceptedDrag;
  }

  protected void checkTransferType(DropTargetDragEvent dtde) {
    // Only accept a flavor that returns a Component
    acceptableType = false;
    DataFlavor[] fl = dtde.getCurrentDataFlavors();
    for (int i = 0; i < fl.length; i++) {
      Class dataClass = fl[i].getRepresentationClass();
      if (Component.class.isAssignableFrom(dataClass)) {
        // This flavor returns a Component - accept it.
        targetFlavor = fl[i];
        acceptableType = true;
        break;
      }
    }
    acceptableType = true;   
  }

  protected boolean dropComponent(Transferable transferable)
      throws IOException, UnsupportedFlavorException {
    Object o = transferable.getTransferData(targetFlavor);
    if (o instanceof Component) {
      return true;
    }
    return false;
  }

  
    public boolean existe(DefaultMutableTreeNode query, String tablename) {
        int j=query.getChildCount();
        boolean existe=false;        
       for(int i=0;i<j;i++)
       {    
           if(query.getChildAt(i).toString().equalsIgnoreCase(tablename))
              existe= true;
        }
        return existe;
    }
    
    public void newTable(String tablename)
    {      this.tablename=tablename;
          Table tab=new Table(connection,tablename,tre_consulta,dndListener);
          if(tab.existe()){
            DefaultTreeModel modelo =(DefaultTreeModel)tre_consulta.getModel();
            DefaultMutableTreeNode query=(DefaultMutableTreeNode)modelo.getChild(modelo.getRoot(),1);
            if(!existe(query,tablename)){
            DefaultMutableTreeNode childfrom = new DefaultMutableTreeNode(tablename);
            modelo.insertNodeInto(childfrom,query,0);
            tre_consulta.setSelectionPath(new TreePath(childfrom.getPath()));            
            if(cont<=5)
                    if(med<tab.getNumAtrib())
                            med=tab.getNumAtrib();
            
            if (cont==5){
                cont=0;medida=med+medida+2;}
            if(medida>40||this.pane.getComponentCount()==0){medida=0;med=0;cont=1;}            
            MyInternalFrame frame = new MyInternalFrame(tablename,tab.getNumAtrib()
                    ,cont,medida,tre_consulta,dndListener);
              cont++;
            frame.add("North",tab);
            frame.add("West",tab.getbox());           
            frame.setVisible(true); 
            pane.add(frame);
            try {
                    frame.setSelected(true);
            } catch (java.beans.PropertyVetoException e) {}
            }
            else{
                    if (demoDialogo2 == null) {
                    JFrame mainFrame = MainApp.getApplication().getMainFrame();
                    demoDialogo2 = new TableAlert(mainFrame,true);
                    demoDialogo2.setLocationRelativeTo(mainFrame);
                     }
                    MainApp.getApplication().show(demoDialogo2);
            }
    }       
    
    }
  public MyJDesktopPane pane;
  protected DropTarget dropTarget;
  protected boolean acceptableType; // Indicates whether data is acceptable
  protected DataFlavor targetFlavor; // Flavor to use for transfer  
}