/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package WorkSpace.CubeConfiguration;

import WorkSpace.MainApp;
import java.awt.Component;
import javax.swing.ImageIcon;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;

/**
 *
 * @author Alexander
 */
public class QueryCellRenderer extends DefaultTreeCellRenderer{		
		public QueryCellRenderer() {
    		super();
    	}
    @Override
        public Component getTreeCellRendererComponent(JTree tree, Object value,
                boolean isSelected, boolean expanded,
                boolean leaf, int row, boolean hasFocus) {
             ImageIcon tabla =createImageIcon("resources/databasetable.png"); 
             ImageIcon db = createImageIcon("resources/database_gear.png"); 
             ImageIcon dbc = createImageIcon("resources/database_connect.png"); 
             ImageIcon campo = createImageIcon("resources/campo.png"); 
             ImageIcon join = createImageIcon("resources/database_link.png"); 
            String  stringValue = tree.convertValueToText(value, isSelected,
                    expanded, leaf, row, hasFocus);
               	this.hasFocus = hasFocus;
        	setText(stringValue);
        	if(isSelected)
        	    setForeground(getTextSelectionColor());
        	else
        	    setForeground(getTextNonSelectionColor());
        	
        	if (!tree.isEnabled()) {
        	    setEnabled(false);
        	}
        	else {
        	    setEnabled(true);
        	}
	        switch(((DefaultMutableTreeNode)value).getLevel()){
    		case 0:
                    setIcon(db);
                    break;
    		case 1:
                    setIcon(dbc);
                    break;
    		case 2:
                        if(tree.getModel().getIndexOfChild(tree.getModel().getRoot(),((DefaultMutableTreeNode)value).getParent())==1)
                            setIcon(tabla);
                        else
                            if(tree.getModel().getIndexOfChild(tree.getModel().getRoot(),((DefaultMutableTreeNode)value).getParent())==2)
                             setIcon(join);
                            else
                               setIcon(campo);
                        break;
	        }
             setComponentOrientation(tree.getComponentOrientation());
        
        	selected = isSelected;

        	return this;
            }
  

   private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = MainApp.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }


 
}
