/*
 * Table.java
 *
 * Created on 30 de septiembre de 2008, 11:23 AM
 */

package WorkSpace.CubeConfiguration;

import WorkSpace.CubeConfiguration.CheckBoxes;
import WorkSpace.CubeConfiguration.DND;
import Core.CubeConfiguration.JdbcManager;
import java.awt.Color;
import java.sql.Connection;
import java.util.Vector;
import javax.swing.JPanel;
import javax.swing.JTree;

/**
 *
 * @author  Alexander 
 */

/**
*Esta Clase es utilizada para mostrar los campos de una tabla de la BD
 */
public class Table extends javax.swing.JPanel {
    Vector nombres = new Vector();
    boolean existe=false;
    /** Creates new form Table */
      CheckBoxes check;
      String tablename;
      JPanel Panel;
       
  /**
  *  Este Constructor recibe como parametro la coneccion a la BD y el nombre 
  *  de la tabla que se va a listar
 */    
    public Table(Connection con,String tablename, JTree tre_consulta,DND dndListener) {
            initComponents();
           // list = new DNDCheckBoxList(tre_consulta);
            super.setBackground(Color.LIGHT_GRAY);
            this.tablename=tablename;
             this.lbl_title.setText(tablename);
            nombres = JdbcManager.getAtributos(con, tablename);
            if(nombres.size()>0){
                check=new CheckBoxes(nombres,tre_consulta,tablename,dndListener);
                existe=true;
            }else{
                existe=false;
            }
            Panel = new JPanel();
            Panel.setBackground(Color.LIGHT_GRAY);
            Panel.add(check);
            
        }
     public Table() {
            initComponents();
           // list = new DNDCheckBoxList(tre_consulta);
            super.setBackground(Color.GRAY);
         
           
     }
      
    public int getNumAtrib(){
        return nombres.size();
     }
     public JPanel getbox(){
        return Panel;
     }

    public boolean existe(){
        return existe;
    }
    
       
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        lbl_title = new javax.swing.JLabel();

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(WorkSpace.MainApp.class).getContext().getResourceMap(Table.class);
        setBackground(resourceMap.getColor("Form.background")); // NOI18N
        setName("Form"); // NOI18N

        lbl_title.setBackground(resourceMap.getColor("lbl_title.background")); // NOI18N
        lbl_title.setFont(resourceMap.getFont("lbl_title.font")); // NOI18N
        lbl_title.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lbl_title.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED, null, null, resourceMap.getColor("lbl_title.border.shadowOuterColor"), resourceMap.getColor("lbl_title.border.shadowInnerColor"))); // NOI18N
        lbl_title.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        lbl_title.setName("lbl_title"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lbl_title, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 120, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lbl_title, javax.swing.GroupLayout.DEFAULT_SIZE, 25, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel lbl_title;
    // End of variables declaration//GEN-END:variables
    
}
