/*
 * Wizard_ConfCube.java
 *
 * Created on 4 de abril de 2008, 10:38 AM
 */
package WorkSpace.CubeConfiguration;


import Core.CubeConfiguration.AccessCube;
import Core.CubeConfiguration.CubeSchemaWriter;
import WorkSpace.CubeConfiguration.DND;
import WorkSpace.CubeConfiguration.DNDList;
import WorkSpace.CubeConfiguration.DimensionCellRenderer;
import Core.CubeConfiguration.JdbcManager;
import WorkSpace.CubeConfiguration.MyDefaultMutableTreeNode;
import WorkSpace.CubeConfiguration.MyJDesktopPane;
import WorkSpace.CubeConfiguration.MyMouseAdapter;
import WorkSpace.CubeConfiguration.MyTableListener;
import WorkSpace.CubeConfiguration.MyTreeSelectionListener;
import WorkSpace.CubeConfiguration.PanelDropTarget;
import WorkSpace.CubeConfiguration.QueryCellRenderer;
import java.awt.*;
import java.sql.Connection;
import java.sql.SQLException;
import javax.swing.JFrame;
import WorkSpace.MainApp;
import WorkSpace.DBconexion.NewConnection;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.IOException;
import java.io.OutputStream;
import java.sql.DriverManager;
import java.util.Iterator;
import java.util.Map;
import java.util.Vector;
import javax.swing.BoxLayout;   
import javax.swing.ComboBoxModel;
import javax.swing.DefaultCellEditor;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JViewport;
import javax.swing.table.DefaultTableModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;
import nu.xom.Serializer;
import org.custommonkey.xmlunit.TolerantSaxDocumentBuilder;
import org.pentaho.core.admin.datasources.DataSourceInfo;
import org.pentaho.ui.common.core.DataStoreManager;
/**
 *
 * @author  Edisoncor
 */
public class Wizard_ConfCube extends javax.swing.JDialog {  
    private Connection connection;
    ImageIcon imagen;
   Connection con=null;      
    protected String username;
    CubeSchemaWriter xml;
    PanelDropTarget pnl;
    DNDList lst_tables = new DNDList();
    ImageIcon icon;
    Vector aux;
    boolean three=false;
    boolean saveflag=false;
    DataSourceInfo editDsi;
    Object factselected=0;
    DND dndListener;
    MyJDesktopPane pnl_contenedor;
    DefaultListModel  listmodel;
    DefaultListModel  listmodel1;
    boolean exito=true;
    private DefaultTreeModel modelo;
    /** Creates new form Wizard_ConfCube */

    @SuppressWarnings("static-access")
      public Wizard_ConfCube(java.awt.Frame parent, boolean modal,Connection con) {
        super(parent, modal);               
        this.con=con;       
        initComponents();  
        this.setDefaultCloseOperation(this.DO_NOTHING_ON_CLOSE);
        this.addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent we) {
                if(!saveflag)
                {JFrame mainFrame = MainApp.getApplication().getMainFrame();
                            demoDialogo4 = new ExitAlert(mainFrame,true);
                            demoDialogo4.setLocationRelativeTo(mainFrame);
                             MainApp.getApplication().show(demoDialogo4);         
                             if(demoDialogo4.getReturnStatus()==1)
                                    dispose();  
                }else
                    dispose();
            }
        });
        tre_consulta.setCellRenderer(new QueryCellRenderer());
        tre_dimension.setCellRenderer(new DimensionCellRenderer());
        imagen = createImageIcon("resources/add.png");
        this.btn_addfact.setIcon(imagen);        
        imagen = createImageIcon("resources/add.png");
        this.btn_addfact1.setIcon(imagen);
        imagen = createImageIcon("resources/del.png");
        this.btn_delfact.setIcon(imagen);
        imagen = createImageIcon("resources/del.png");
        this.btn_delfact1.setIcon(imagen);                
        pnl_contenedor=new MyJDesktopPane(this.dndListener,tre_consulta);        
        jPanel6.setLayout(new BoxLayout(jPanel6, BoxLayout.X_AXIS));
        setJNDINames();
        cbx_type.addItem("TABLE");
        cbx_type.addItem("SYSTEM TABLE");
        cbx_type.addItem("GLOBAL");
        cbx_type.addItem("TEMPORARY");
        cbx_type.addItem("LOCAL TEMPORARY");
        DefaultTableModel auxtbl=(DefaultTableModel)this.tbl_dimensionProperties.getModel();
        this.tre_dimension.getSelectionModel().addTreeSelectionListener(new MyTreeSelectionListener(auxtbl));
        auxtbl.addTableModelListener(new MyTableListener(this.tre_dimension,this.tbl_dimensionProperties));
        this.tbl_dimensionProperties.addMouseListener(new MyMouseAdapter(auxtbl));
        this.jSplitPane1.setResizeWeight(0.30);
        this.lst_dsconnection.setSelectedIndex(0);   
        DefaultTreeModel  treeModel = (DefaultTreeModel)tre_dimension.getModel();
        treeModel.addTreeModelListener(new MyTreeModelListener()); 
        tre_dimension.getSelectionModel().setSelectionMode
        (TreeSelectionModel.SINGLE_TREE_SELECTION);
        tre_dimension.setShowsRootHandles(true);
        super.setLocation(1,1);                
        super.setMinimumSize(new Dimension(MainApp.getApplication().getMainFrame().getSize().width,(MainApp.getApplication().getMainFrame().getSize().height))); 
  }   
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btng_access = new javax.swing.ButtonGroup();
        btn_back = new javax.swing.JButton();
        btn_next = new javax.swing.JButton();
        btn_cancel = new javax.swing.JButton();
        jsp_main = new javax.swing.JSeparator();
        pnl_main = new javax.swing.JPanel();
        pnl_step1 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        txt_cubename = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        btn_add = new javax.swing.JButton();
        btn_edit = new javax.swing.JButton();
        btn_remove = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        lst_dsconnection = new javax.swing.JList();
        jLabel1 = new javax.swing.JLabel();
        jLabel20 = new javax.swing.JLabel();
        pnl_step2 = new javax.swing.JPanel();
        jSplitPane1 = new javax.swing.JSplitPane();
        jSplitPane2 = new javax.swing.JSplitPane();
        jScrollPane2 = new javax.swing.JScrollPane();
        DefaultMutableTreeNode query = new DefaultMutableTreeNode("QUERY");
        DefaultMutableTreeNode select = new DefaultMutableTreeNode("SELECT");
        DefaultMutableTreeNode from = new DefaultMutableTreeNode("FROM");
        DefaultMutableTreeNode join = new DefaultMutableTreeNode("JOIN");
        query.add(select);
        query.add(from);
        query.add(join);
        tre_consulta = new javax.swing.JTree(query);
        jPanel3 = new javax.swing.JPanel();
        cbx_type = new javax.swing.JComboBox();
        jPanel6 = new javax.swing.JPanel();
        jsc_table = new javax.swing.JScrollPane();
        jLabel2 = new javax.swing.JLabel();
        pnl_step3 = new javax.swing.JPanel();
        jSeparator5 = new javax.swing.JSeparator();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jLabel11 = new javax.swing.JLabel();
        jScrollPane4 = new javax.swing.JScrollPane();
        tbl_measures = new javax.swing.JTable();
        jScrollPane3 = new javax.swing.JScrollPane();
        lst_columsfact = new javax.swing.JList();
        jLabel10 = new javax.swing.JLabel();
        cbx_facttables = new javax.swing.JComboBox();
        jLabel9 = new javax.swing.JLabel();
        btn_addfact = new javax.swing.JButton();
        btn_delfact = new javax.swing.JButton();
        jLabel21 = new javax.swing.JLabel();
        pnl_step4 = new javax.swing.JPanel();
        jSeparator8 = new javax.swing.JSeparator();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jPanel5 = new javax.swing.JPanel();
        jLabel14 = new javax.swing.JLabel();
        jScrollPane6 = new javax.swing.JScrollPane();
        lst_fielddimension = new javax.swing.JList();
        jLabel15 = new javax.swing.JLabel();
        btn_addfact1 = new javax.swing.JButton();
        btn_delfact1 = new javax.swing.JButton();
        jScrollPane5 = new javax.swing.JScrollPane();
        query = new MyDefaultMutableTreeNode("QUERY");
        tre_dimension = new javax.swing.JTree(query);
        btn_adddimension = new javax.swing.JButton();
        jXTaskPane1 = new org.jdesktop.swingx.JXTaskPane();
        jPanel8 = new javax.swing.JPanel();
        jScrollPane7 = new javax.swing.JScrollPane();
        tbl_dimensionProperties = new javax.swing.JTable();
        btn_hierarchy = new javax.swing.JButton();
        jLabel22 = new javax.swing.JLabel();
        pnl_step5 = new javax.swing.JPanel();
        jtp_resumen = new javax.swing.JTabbedPane();
        pnl_savecube = new javax.swing.JPanel();
        jScrollPane8 = new javax.swing.JScrollPane();
        txa_xml = new javax.swing.JTextArea();
        pnl_access = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jPanel9 = new javax.swing.JPanel();
        btn_private = new javax.swing.JRadioButton();
        btn_public = new javax.swing.JRadioButton();
        jScrollPane9 = new javax.swing.JScrollPane();
        tbl_access = new javax.swing.JTable();
        pnl_reviewcube = new javax.swing.JPanel();
        jLabel16 = new javax.swing.JLabel();
        jPanel7 = new javax.swing.JPanel();
        jLabel17 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        btn_savexml = new javax.swing.JButton();
        txt_reviewcube = new javax.swing.JTextField();
        lbl_cubook = new javax.swing.JLabel();
        lbl_ico1 = new javax.swing.JLabel();
        jLabel23 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(WorkSpace.MainApp.class).getContext().getResourceMap(Wizard_ConfCube.class);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setName("Form"); // NOI18N

        btn_back.setFont(resourceMap.getFont("btn_back.font")); // NOI18N
        btn_back.setText(resourceMap.getString("btn_back.text")); // NOI18N
        btn_back.setEnabled(false);
        btn_back.setName("btn_back"); // NOI18N
        btn_back.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BackActionPerformed(evt);
            }
        });

        btn_next.setFont(resourceMap.getFont("btn_next.font")); // NOI18N
        btn_next.setText(resourceMap.getString("btn_next.text")); // NOI18N
        btn_next.setEnabled(false);
        btn_next.setName("btn_next"); // NOI18N
        btn_next.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                NextActionPerformed(evt);
            }
        });

        btn_cancel.setFont(resourceMap.getFont("btn_cancel.font")); // NOI18N
        btn_cancel.setText(resourceMap.getString("btn_cancel.text")); // NOI18N
        btn_cancel.setName("btn_cancel"); // NOI18N
        btn_cancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CancelActionPerformed(evt);
            }
        });

        jsp_main.setName("jsp_main"); // NOI18N
        jsp_main.setPreferredSize(new java.awt.Dimension(0, 0));

        pnl_main.setName("pnl_main"); // NOI18N
        pnl_main.setLayout(new java.awt.CardLayout());

        pnl_step1.setName("pnl_step1"); // NOI18N

        jPanel1.setName("jPanel1"); // NOI18N

        jLabel3.setFont(resourceMap.getFont("jLabel3.font")); // NOI18N
        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        txt_cubename.setName("txt_cubename"); // NOI18N
        txt_cubename.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                evt_namecube(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(txt_cubename, javax.swing.GroupLayout.PREFERRED_SIZE, 176, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 63, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(799, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txt_cubename, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(38, Short.MAX_VALUE))
        );

        jPanel2.setName("jPanel2"); // NOI18N

        jLabel5.setFont(resourceMap.getFont("jLabel5.font")); // NOI18N
        jLabel5.setText(resourceMap.getString("jLabel5.text")); // NOI18N
        jLabel5.setName("jLabel5"); // NOI18N

        jLabel6.setText(resourceMap.getString("jLabel6.text")); // NOI18N
        jLabel6.setName("jLabel6"); // NOI18N

        btn_add.setText(resourceMap.getString("btn_add.text")); // NOI18N
        btn_add.setName("btn_add"); // NOI18N
        btn_add.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btn_addMouseClicked(evt);
            }
        });

        btn_edit.setText(resourceMap.getString("btn_edit.text")); // NOI18N
        btn_edit.setName("btn_edit"); // NOI18N
        btn_edit.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                evn_edit(evt);
            }
        });

        btn_remove.setText(resourceMap.getString("btn_remove.text")); // NOI18N
        btn_remove.setName("btn_remove"); // NOI18N
        btn_remove.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                evn_remove(evt);
            }
        });

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        lst_dsconnection.setName("lst_dsconnection"); // NOI18N
        lst_dsconnection.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                evt_listasources(evt);
            }
        });
        jScrollPane1.setViewportView(lst_dsconnection);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 119, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(btn_add)
                        .addGap(15, 15, 15)
                        .addComponent(btn_edit)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(btn_remove))
                    .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 676, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 300, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(299, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(3, 3, 3)
                .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(22, 22, 22)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btn_edit)
                    .addComponent(btn_remove)
                    .addComponent(btn_add))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 95, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(52, Short.MAX_VALUE))
        );

        jLabel1.setName("jLabel1"); // NOI18N

        jLabel20.setIcon(resourceMap.getIcon("jLabel20.icon")); // NOI18N
        jLabel20.setText(resourceMap.getString("jLabel20.text")); // NOI18N
        jLabel20.setName("jLabel20"); // NOI18N
        jLabel20.setPreferredSize(null);

        javax.swing.GroupLayout pnl_step1Layout = new javax.swing.GroupLayout(pnl_step1);
        pnl_step1.setLayout(pnl_step1Layout);
        pnl_step1Layout.setHorizontalGroup(
            pnl_step1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jLabel20, javax.swing.GroupLayout.PREFERRED_SIZE, 1171, Short.MAX_VALUE)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnl_step1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 162, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
            .addGroup(pnl_step1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(176, 176, 176))
        );
        pnl_step1Layout.setVerticalGroup(
            pnl_step1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnl_step1Layout.createSequentialGroup()
                .addComponent(jLabel20, javax.swing.GroupLayout.DEFAULT_SIZE, 153, Short.MAX_VALUE)
                .addGap(57, 57, 57)
                .addGroup(pnl_step1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnl_step1Layout.createSequentialGroup()
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(493, 493, 493))
                    .addGroup(pnl_step1Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(42, 42, 42)
                        .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())))
        );

        pnl_main.add(pnl_step1, "1");

        pnl_step2.setName("pnl_step2"); // NOI18N

        jSplitPane1.setToolTipText(resourceMap.getString("jSplitPane1.toolTipText")); // NOI18N
        jSplitPane1.setAutoscrolls(true);
        jSplitPane1.setName("jSplitPane1"); // NOI18N
        jSplitPane1.setOneTouchExpandable(true);

        jSplitPane2.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane2.setAutoscrolls(true);
        jSplitPane2.setName("jSplitPane2"); // NOI18N
        jSplitPane2.setOneTouchExpandable(true);

        jScrollPane2.setName("jScrollPane2"); // NOI18N

        tre_consulta.setFont(resourceMap.getFont("tre_consulta.font")); // NOI18N
        tre_consulta.setToolTipText(resourceMap.getString("tre_consulta.toolTipText")); // NOI18N
        tre_consulta.setAutoscrolls(true);
        tre_consulta.setFocusTraversalPolicyProvider(true);
        tre_consulta.setLargeModel(true);
        tre_consulta.setName("tre_consulta"); // NOI18N
        tre_consulta.putClientProperty("JTree.lineStyle", "Horizontal");
        tre_consulta.setShowsRootHandles(true);
        jScrollPane2.setViewportView(tre_consulta);

        jSplitPane2.setTopComponent(jScrollPane2);

        jPanel3.setName("jPanel3"); // NOI18N

        cbx_type.setName("cbx_type"); // NOI18N
        cbx_type.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                evt_cambiartablas(evt);
            }
        });

        jPanel6.setName("jPanel6"); // NOI18N

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 97, Short.MAX_VALUE)
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 463, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(cbx_type, javax.swing.GroupLayout.Alignment.TRAILING, 0, 117, Short.MAX_VALUE)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(cbx_type, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jSplitPane2.setBottomComponent(jPanel3);

        jSplitPane1.setLeftComponent(jSplitPane2);

        jsc_table.setBackground(resourceMap.getColor("jsc_table.background")); // NOI18N
        jsc_table.setAutoscrolls(true);
        jsc_table.setName("jsc_table"); // NOI18N
        jSplitPane1.setRightComponent(jsc_table);

        jLabel2.setIcon(resourceMap.getIcon("jLabel2.icon")); // NOI18N
        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N
        jLabel2.setPreferredSize(null);

        javax.swing.GroupLayout pnl_step2Layout = new javax.swing.GroupLayout(pnl_step2);
        pnl_step2.setLayout(pnl_step2Layout);
        pnl_step2Layout.setHorizontalGroup(
            pnl_step2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 1171, Short.MAX_VALUE)
            .addGroup(pnl_step2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 1151, Short.MAX_VALUE)
                .addContainerGap())
        );
        pnl_step2Layout.setVerticalGroup(
            pnl_step2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_step2Layout.createSequentialGroup()
                .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, 187, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 532, Short.MAX_VALUE))
        );

        pnl_main.add(pnl_step2, "2");

        pnl_step3.setName("pnl_step3"); // NOI18N

        jSeparator5.setName("jSeparator5"); // NOI18N

        jLabel7.setFont(resourceMap.getFont("jLabel7.font")); // NOI18N
        jLabel7.setText(resourceMap.getString("jLabel7.text")); // NOI18N
        jLabel7.setName("jLabel7"); // NOI18N

        jLabel8.setText(resourceMap.getString("jLabel8.text")); // NOI18N
        jLabel8.setName("jLabel8"); // NOI18N

        jPanel4.setName("jPanel4"); // NOI18N

        jLabel11.setFont(resourceMap.getFont("jLabel11.font")); // NOI18N
        jLabel11.setText(resourceMap.getString("jLabel11.text")); // NOI18N
        jLabel11.setName("jLabel11"); // NOI18N

        jScrollPane4.setName("jScrollPane4"); // NOI18N

        tbl_measures.setBackground(resourceMap.getColor("tbl_measures.background")); // NOI18N
        tbl_measures.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Source Field", "Aggregator", "Format", "Measures"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, true, true, true
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                int a=this.getRowCount()-42;
                if(rowIndex<Math.abs(a)&&columnIndex!=0)
                return true;
                else
                return false;//canEdit [columnIndex];
            }
        });
        tbl_measures.setColumnSelectionAllowed(true);
        tbl_measures.setName("tbl_measures"); // NOI18N
        tbl_measures.getTableHeader().setReorderingAllowed(false);
        jScrollPane4.setViewportView(tbl_measures);
        aggregator = new JComboBox(new String[]{"SUM", "AVG", "COUNT","MIN", "MAX"});
        format = new JComboBox(new String[]{"Standard", "#.##0"});
        tbl_measures.getColumnModel().getColumn(1).setCellEditor(new DefaultCellEditor(aggregator));
        tbl_measures.getColumnModel().getColumn(2).setCellEditor(new DefaultCellEditor(format));
        tbl_measures.getColumnModel().getSelectionModel().setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);

        jScrollPane3.setName("jScrollPane3"); // NOI18N

        lst_columsfact.setName("lst_columsfact"); // NOI18N
        jScrollPane3.setViewportView(lst_columsfact);

        jLabel10.setFont(resourceMap.getFont("jLabel10.font")); // NOI18N
        jLabel10.setText(resourceMap.getString("jLabel10.text")); // NOI18N
        jLabel10.setName("jLabel10"); // NOI18N

        cbx_facttables.setName("cbx_facttables"); // NOI18N
        cbx_facttables.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                evt_facttables(evt);
            }
        });

        jLabel9.setFont(resourceMap.getFont("jLabel9.font")); // NOI18N
        jLabel9.setText(resourceMap.getString("jLabel9.text")); // NOI18N
        jLabel9.setName("jLabel9"); // NOI18N

        btn_addfact.setText(resourceMap.getString("btn_addfact.text")); // NOI18N
        btn_addfact.setName("btn_addfact"); // NOI18N
        btn_addfact.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                evt_addfact(evt);
            }
        });

        btn_delfact.setText(resourceMap.getString("btn_delfact.text")); // NOI18N
        btn_delfact.setName("btn_delfact"); // NOI18N
        btn_delfact.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                evt_delfact(evt);
            }
        });

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, 111, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(cbx_facttables, javax.swing.GroupLayout.Alignment.TRAILING, 0, 232, Short.MAX_VALUE)
                    .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, 111, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 279, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(btn_addfact, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(btn_delfact, javax.swing.GroupLayout.DEFAULT_SIZE, 47, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel11, javax.swing.GroupLayout.PREFERRED_SIZE, 111, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 803, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGap(148, 148, 148)
                        .addComponent(btn_addfact, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(btn_delfact, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(cbx_facttables, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jLabel11, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 324, Short.MAX_VALUE)
                            .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 324, Short.MAX_VALUE))))
                .addContainerGap())
        );

        jLabel21.setIcon(resourceMap.getIcon("jLabel21.icon")); // NOI18N
        jLabel21.setText(resourceMap.getString("jLabel21.text")); // NOI18N
        jLabel21.setName("jLabel21"); // NOI18N
        jLabel21.setPreferredSize(null);

        javax.swing.GroupLayout pnl_step3Layout = new javax.swing.GroupLayout(pnl_step3);
        pnl_step3.setLayout(pnl_step3Layout);
        pnl_step3Layout.setHorizontalGroup(
            pnl_step3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_step3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnl_step3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(pnl_step3Layout.createSequentialGroup()
                        .addGroup(pnl_step3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jSeparator5, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 1151, Short.MAX_VALUE)
                            .addComponent(jLabel7, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 111, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel8, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 806, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addContainerGap())))
            .addComponent(jLabel21, javax.swing.GroupLayout.PREFERRED_SIZE, 1171, Short.MAX_VALUE)
        );
        pnl_step3Layout.setVerticalGroup(
            pnl_step3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_step3Layout.createSequentialGroup()
                .addComponent(jLabel21, javax.swing.GroupLayout.DEFAULT_SIZE, 222, Short.MAX_VALUE)
                .addGap(22, 22, 22)
                .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator5, javax.swing.GroupLayout.PREFERRED_SIZE, 11, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        pnl_main.add(pnl_step3, "3");

        pnl_step4.setName("pnl_step4"); // NOI18N

        jSeparator8.setName("jSeparator8"); // NOI18N

        jLabel12.setFont(resourceMap.getFont("jLabel12.font")); // NOI18N
        jLabel12.setText(resourceMap.getString("jLabel12.text")); // NOI18N
        jLabel12.setName("jLabel12"); // NOI18N

        jLabel13.setText(resourceMap.getString("jLabel13.text")); // NOI18N
        jLabel13.setName("jLabel13"); // NOI18N

        jPanel5.setName("jPanel5"); // NOI18N

        jLabel14.setFont(resourceMap.getFont("jLabel14.font")); // NOI18N
        jLabel14.setText(resourceMap.getString("jLabel14.text")); // NOI18N
        jLabel14.setName("jLabel14"); // NOI18N

        jScrollPane6.setName("jScrollPane6"); // NOI18N

        lst_fielddimension.setName("lst_fielddimension"); // NOI18N
        jScrollPane6.setViewportView(lst_fielddimension);

        jLabel15.setFont(resourceMap.getFont("jLabel15.font")); // NOI18N
        jLabel15.setText(resourceMap.getString("jLabel15.text")); // NOI18N
        jLabel15.setName("jLabel15"); // NOI18N

        btn_addfact1.setIcon(resourceMap.getIcon("btn_addfact1.icon")); // NOI18N
        btn_addfact1.setText(resourceMap.getString("btn_addfact1.text")); // NOI18N
        btn_addfact1.setName("btn_addfact1"); // NOI18N
        btn_addfact1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                evt_adddimensionlevel(evt);
            }
        });

        btn_delfact1.setText(resourceMap.getString("btn_delfact1.text")); // NOI18N
        btn_delfact1.setName("btn_delfact1"); // NOI18N
        btn_delfact1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                evt_deldimensionlevel(evt);
            }
        });

        jScrollPane5.setName("jScrollPane5"); // NOI18N

        tre_dimension.setName("tre_dimension"); // NOI18N
        tre_dimension.setRootVisible(false);
        jScrollPane5.setViewportView(tre_dimension);

        btn_adddimension.setText(resourceMap.getString("btn_adddimension.text")); // NOI18N
        btn_adddimension.setName("btn_adddimension"); // NOI18N
        btn_adddimension.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_adddimension(evt);
            }
        });

        jXTaskPane1.setTitle(resourceMap.getString("jXTaskPane1.title")); // NOI18N
        jXTaskPane1.setName("jXTaskPane1"); // NOI18N

        jPanel8.setName("jPanel8"); // NOI18N

        jScrollPane7.setName("jScrollPane7"); // NOI18N

        tbl_dimensionProperties.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "Property", "Value"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, true
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                if((rowIndex==0||rowIndex==2)&&columnIndex==1)
                return true;
                else
                return false;//canEdit [columnIndex];
            }
        });
        tbl_dimensionProperties.setName("tbl_dimensionProperties"); // NOI18N
        jScrollPane7.setViewportView(tbl_dimensionProperties);
        tbl_dimensionProperties.getColumnModel().getColumn(0).setResizable(false);
        tbl_dimensionProperties.getColumnModel().getColumn(1).setResizable(false);

        javax.swing.GroupLayout jPanel8Layout = new javax.swing.GroupLayout(jPanel8);
        jPanel8.setLayout(jPanel8Layout);
        jPanel8Layout.setHorizontalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane7, javax.swing.GroupLayout.DEFAULT_SIZE, 695, Short.MAX_VALUE)
        );
        jPanel8Layout.setVerticalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane7, javax.swing.GroupLayout.DEFAULT_SIZE, 71, Short.MAX_VALUE)
        );

        jXTaskPane1.getContentPane().add(jPanel8);

        btn_hierarchy.setText(resourceMap.getString("btn_hierarchy.text")); // NOI18N
        btn_hierarchy.setName("btn_hierarchy"); // NOI18N
        btn_hierarchy.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_hierarchyActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGap(24, 24, 24)
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane6, javax.swing.GroupLayout.PREFERRED_SIZE, 337, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel15, javax.swing.GroupLayout.PREFERRED_SIZE, 134, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(btn_delfact1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(btn_addfact1, javax.swing.GroupLayout.PREFERRED_SIZE, 42, Short.MAX_VALUE)))
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGap(55, 55, 55)
                        .addComponent(btn_adddimension, javax.swing.GroupLayout.PREFERRED_SIZE, 147, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btn_hierarchy, javax.swing.GroupLayout.PREFERRED_SIZE, 117, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addComponent(jLabel14, javax.swing.GroupLayout.PREFERRED_SIZE, 111, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap(645, Short.MAX_VALUE))
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addComponent(jXTaskPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 717, Short.MAX_VALUE)
                        .addGap(128, 128, 128))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel5Layout.createSequentialGroup()
                        .addComponent(jScrollPane5, javax.swing.GroupLayout.PREFERRED_SIZE, 785, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel14, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel15, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(6, 6, 6)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 199, Short.MAX_VALUE)
                    .addComponent(jScrollPane6, javax.swing.GroupLayout.DEFAULT_SIZE, 199, Short.MAX_VALUE)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGap(23, 23, 23)
                        .addComponent(btn_addfact1, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btn_delfact1, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(57, 57, 57)))
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jXTaskPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGap(80, 80, 80)
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(btn_hierarchy)
                            .addComponent(btn_adddimension))))
                .addContainerGap())
        );

        jLabel22.setIcon(resourceMap.getIcon("jLabel22.icon")); // NOI18N
        jLabel22.setText(resourceMap.getString("jLabel22.text")); // NOI18N
        jLabel22.setName("jLabel22"); // NOI18N
        jLabel22.setPreferredSize(null);

        javax.swing.GroupLayout pnl_step4Layout = new javax.swing.GroupLayout(pnl_step4);
        pnl_step4.setLayout(pnl_step4Layout);
        pnl_step4Layout.setHorizontalGroup(
            pnl_step4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel5, 0, 1171, Short.MAX_VALUE)
            .addGroup(pnl_step4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnl_step4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel12, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 111, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jSeparator8, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 1161, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel13, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 805, javax.swing.GroupLayout.PREFERRED_SIZE)))
            .addComponent(jLabel22, javax.swing.GroupLayout.PREFERRED_SIZE, 1171, Short.MAX_VALUE)
        );
        pnl_step4Layout.setVerticalGroup(
            pnl_step4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_step4Layout.createSequentialGroup()
                .addComponent(jLabel22, javax.swing.GroupLayout.DEFAULT_SIZE, 219, Short.MAX_VALUE)
                .addGap(83, 83, 83)
                .addComponent(jLabel12, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel13, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator8, javax.swing.GroupLayout.PREFERRED_SIZE, 11, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pnl_main.add(pnl_step4, "4");

        pnl_step5.setName("pnl_step5"); // NOI18N

        jtp_resumen.setTabPlacement(javax.swing.JTabbedPane.LEFT);
        jtp_resumen.setToolTipText(resourceMap.getString("jtp_resumen.toolTipText")); // NOI18N
        jtp_resumen.setFont(resourceMap.getFont("jtp_resumen.font")); // NOI18N
        jtp_resumen.setName("jtp_resumen"); // NOI18N

        pnl_savecube.setFont(resourceMap.getFont("pnl_savecube.font")); // NOI18N
        pnl_savecube.setName("pnl_savecube"); // NOI18N

        jScrollPane8.setName("jScrollPane8"); // NOI18N

        txa_xml.setColumns(20);
        txa_xml.setRows(5);
        txa_xml.setName("txa_xml"); // NOI18N
        jScrollPane8.setViewportView(txa_xml);

        javax.swing.GroupLayout pnl_savecubeLayout = new javax.swing.GroupLayout(pnl_savecube);
        pnl_savecube.setLayout(pnl_savecubeLayout);
        pnl_savecubeLayout.setHorizontalGroup(
            pnl_savecubeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_savecubeLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane8, javax.swing.GroupLayout.DEFAULT_SIZE, 959, Short.MAX_VALUE)
                .addContainerGap())
        );
        pnl_savecubeLayout.setVerticalGroup(
            pnl_savecubeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_savecubeLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane8, javax.swing.GroupLayout.DEFAULT_SIZE, 476, Short.MAX_VALUE)
                .addContainerGap())
        );

        jtp_resumen.addTab(resourceMap.getString("pnl_savecube.TabConstraints.tabTitle"), pnl_savecube); // NOI18N

        pnl_access.setName("pnl_access"); // NOI18N

        jLabel4.setText(resourceMap.getString("jLabel4.text")); // NOI18N
        jLabel4.setName("jLabel4"); // NOI18N

        jPanel9.setName("jPanel9"); // NOI18N

        btng_access.add(btn_private);
        btn_private.setText(resourceMap.getString("btn_private.text")); // NOI18N
        btn_private.setToolTipText(resourceMap.getString("btn_private.toolTipText")); // NOI18N
        btn_private.setName("btn_private"); // NOI18N
        btn_private.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_privateActionPerformed(evt);
            }
        });

        btng_access.add(btn_public);
        btn_public.setSelected(true);
        btn_public.setText(resourceMap.getString("btn_public.text")); // NOI18N
        btn_public.setToolTipText(resourceMap.getString("btn_public.toolTipText")); // NOI18N
        btn_public.setName("btn_public"); // NOI18N
        btn_public.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_publicActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel9Layout.createSequentialGroup()
                .addGap(33, 33, 33)
                .addComponent(btn_private)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 45, Short.MAX_VALUE)
                .addComponent(btn_public)
                .addGap(42, 42, 42))
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel9Layout.createSequentialGroup()
                .addContainerGap(14, Short.MAX_VALUE)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btn_public)
                    .addComponent(btn_private))
                .addContainerGap())
        );

        jScrollPane9.setName("jScrollPane9"); // NOI18N

        tbl_access.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Usuario (Name)", "Allow"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Object.class, java.lang.Boolean.class
            };
            boolean[] canEdit = new boolean [] {
                false, true
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tbl_access.setName("tbl_access"); // NOI18N
        tbl_access.getTableHeader().setReorderingAllowed(false);
        jScrollPane9.setViewportView(tbl_access);
        tbl_access.getColumnModel().getColumn(0).setResizable(false);
        tbl_access.getColumnModel().getColumn(1).setResizable(false);
        tbl_access.getColumnModel().getColumn(1).setCellEditor(new DefaultCellEditor(new JCheckBox()));

        javax.swing.GroupLayout pnl_accessLayout = new javax.swing.GroupLayout(pnl_access);
        pnl_access.setLayout(pnl_accessLayout);
        pnl_accessLayout.setHorizontalGroup(
            pnl_accessLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_accessLayout.createSequentialGroup()
                .addGroup(pnl_accessLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnl_accessLayout.createSequentialGroup()
                        .addGap(114, 114, 114)
                        .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(pnl_accessLayout.createSequentialGroup()
                        .addGap(102, 102, 102)
                        .addComponent(jScrollPane9, javax.swing.GroupLayout.PREFERRED_SIZE, 272, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(pnl_accessLayout.createSequentialGroup()
                        .addGap(90, 90, 90)
                        .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 337, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(552, Short.MAX_VALUE))
        );
        pnl_accessLayout.setVerticalGroup(
            pnl_accessLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_accessLayout.createSequentialGroup()
                .addGap(33, 33, 33)
                .addComponent(jLabel4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane9, javax.swing.GroupLayout.PREFERRED_SIZE, 214, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(176, Short.MAX_VALUE))
        );

        jtp_resumen.addTab(resourceMap.getString("pnl_access.TabConstraints.tabTitle"), pnl_access); // NOI18N

        pnl_reviewcube.setFont(resourceMap.getFont("pnl_reviewcube.font")); // NOI18N
        pnl_reviewcube.setName("pnl_reviewcube"); // NOI18N

        jLabel16.setFont(resourceMap.getFont("jLabel16.font")); // NOI18N
        jLabel16.setText(resourceMap.getString("jLabel16.text")); // NOI18N
        jLabel16.setName("jLabel16"); // NOI18N

        jPanel7.setName("jPanel7"); // NOI18N

        jLabel17.setText(resourceMap.getString("jLabel17.text")); // NOI18N
        jLabel17.setName("jLabel17"); // NOI18N

        jLabel18.setText(resourceMap.getString("jLabel18.text")); // NOI18N
        jLabel18.setName("jLabel18"); // NOI18N

        jLabel19.setText(resourceMap.getString("jLabel19.text")); // NOI18N
        jLabel19.setName("jLabel19"); // NOI18N

        btn_savexml.setText(resourceMap.getString("btn_savexml.text")); // NOI18N
        btn_savexml.setName("btn_savexml"); // NOI18N
        btn_savexml.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                evt_btn_savexml(evt);
            }
        });

        txt_reviewcube.setText(resourceMap.getString("txt_reviewcube.text")); // NOI18N
        txt_reviewcube.setName("txt_reviewcube"); // NOI18N

        javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel7Layout.createSequentialGroup()
                        .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel17, javax.swing.GroupLayout.PREFERRED_SIZE, 89, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel18, javax.swing.GroupLayout.PREFERRED_SIZE, 77, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel19, javax.swing.GroupLayout.DEFAULT_SIZE, 182, Short.MAX_VALUE)
                            .addComponent(txt_reviewcube, javax.swing.GroupLayout.PREFERRED_SIZE, 104, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addContainerGap())
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel7Layout.createSequentialGroup()
                        .addComponent(btn_savexml)
                        .addGap(115, 115, 115))))
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addGap(23, 23, 23)
                .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel17, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(txt_reviewcube, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel19, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel18))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(btn_savexml)
                .addContainerGap())
        );

        lbl_cubook.setFont(resourceMap.getFont("lbl_cubook.font")); // NOI18N
        lbl_cubook.setText(resourceMap.getString("lbl_cubook.text")); // NOI18N
        lbl_cubook.setName("lbl_cubook"); // NOI18N

        lbl_ico1.setText(resourceMap.getString("lbl_ico1.text")); // NOI18N
        lbl_ico1.setName("lbl_ico1"); // NOI18N

        javax.swing.GroupLayout pnl_reviewcubeLayout = new javax.swing.GroupLayout(pnl_reviewcube);
        pnl_reviewcube.setLayout(pnl_reviewcubeLayout);
        pnl_reviewcubeLayout.setHorizontalGroup(
            pnl_reviewcubeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_reviewcubeLayout.createSequentialGroup()
                .addGroup(pnl_reviewcubeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnl_reviewcubeLayout.createSequentialGroup()
                        .addGap(126, 126, 126)
                        .addComponent(jLabel16, javax.swing.GroupLayout.PREFERRED_SIZE, 163, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(pnl_reviewcubeLayout.createSequentialGroup()
                        .addGap(64, 64, 64)
                        .addComponent(lbl_ico1, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGroup(pnl_reviewcubeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(pnl_reviewcubeLayout.createSequentialGroup()
                                .addGap(19, 19, 19)
                                .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(pnl_reviewcubeLayout.createSequentialGroup()
                                .addGap(18, 18, 18)
                                .addComponent(lbl_cubook, javax.swing.GroupLayout.PREFERRED_SIZE, 355, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addContainerGap(484, Short.MAX_VALUE))
        );
        pnl_reviewcubeLayout.setVerticalGroup(
            pnl_reviewcubeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnl_reviewcubeLayout.createSequentialGroup()
                .addContainerGap(66, Short.MAX_VALUE)
                .addComponent(jLabel16)
                .addGap(50, 50, 50)
                .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(29, 29, 29)
                .addGroup(pnl_reviewcubeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(lbl_cubook, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(lbl_ico1, javax.swing.GroupLayout.DEFAULT_SIZE, 58, Short.MAX_VALUE))
                .addGap(158, 158, 158))
        );

        jtp_resumen.addTab(resourceMap.getString("pnl_reviewcube.TabConstraints.tabTitle"), pnl_reviewcube); // NOI18N

        jLabel23.setIcon(resourceMap.getIcon("jLabel23.icon")); // NOI18N
        jLabel23.setText(resourceMap.getString("jLabel23.text")); // NOI18N
        jLabel23.setName("jLabel23"); // NOI18N
        jLabel23.setPreferredSize(null);

        javax.swing.GroupLayout pnl_step5Layout = new javax.swing.GroupLayout(pnl_step5);
        pnl_step5.setLayout(pnl_step5Layout);
        pnl_step5Layout.setHorizontalGroup(
            pnl_step5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_step5Layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(jtp_resumen, javax.swing.GroupLayout.DEFAULT_SIZE, 1151, Short.MAX_VALUE)
                .addContainerGap())
            .addComponent(jLabel23, javax.swing.GroupLayout.PREFERRED_SIZE, 1171, Short.MAX_VALUE)
        );
        pnl_step5Layout.setVerticalGroup(
            pnl_step5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_step5Layout.createSequentialGroup()
                .addComponent(jLabel23, javax.swing.GroupLayout.DEFAULT_SIZE, 205, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jtp_resumen, javax.swing.GroupLayout.DEFAULT_SIZE, 503, Short.MAX_VALUE)
                .addContainerGap())
        );

        jtp_resumen.getAccessibleContext().setAccessibleName(resourceMap.getString("jtp_resumen.AccessibleContext.accessibleName")); // NOI18N

        pnl_main.add(pnl_step5, "5");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(192, 192, 192)
                .addComponent(btn_back, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(btn_next, javax.swing.GroupLayout.PREFERRED_SIZE, 68, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(btn_cancel, javax.swing.GroupLayout.PREFERRED_SIZE, 66, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(724, Short.MAX_VALUE))
            .addComponent(pnl_main, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jsp_main, javax.swing.GroupLayout.DEFAULT_SIZE, 1171, Short.MAX_VALUE)
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {btn_back, btn_cancel, btn_next});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(pnl_main, javax.swing.GroupLayout.DEFAULT_SIZE, 725, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jsp_main, javax.swing.GroupLayout.DEFAULT_SIZE, 7, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btn_next, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btn_back, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btn_cancel, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {btn_back, btn_cancel, btn_next});

        getAccessibleContext().setAccessibleName(resourceMap.getString("Form.AccessibleContext.accessibleName")); // NOI18N

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void BackActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BackActionPerformed
        // TODO add your handling code here:
        //determine previous card to display
     txa_xml.setText("");
    CardLayout cl = (CardLayout)(pnl_main.getLayout());
    String card = String.valueOf(currentDisplayNum-1);
    if(currentDisplayNum == 3){ 
        //need to show second screen
        //change next button text
        this.three=true;
        btn_next.setEnabled(true);       
        this.lst_tables.removeAll();
        this.lst_tables.repaint();
    }      
    else if(currentDisplayNum == 2) {
        resetGUI();
        btn_back.setEnabled(false);     
        }else if(currentDisplayNum == 4) {
              if(this.tbl_measures.getRowCount()==42)
            this.btn_next.setEnabled(false);
        else btn_next.setEnabled(true);
        }else if(currentDisplayNum == 5) {
            this.btn_next.setText("Next");
        }      
    //show card
    cl.show(pnl_main, card);
    //update display number for non-1 numbers
    currentDisplayNum = currentDisplayNum > 1?(--currentDisplayNum):1;
    }//GEN-LAST:event_BackActionPerformed

    @SuppressWarnings("static-access")
    private void NextActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_NextActionPerformed
        if(currentDisplayNum==1){
           if(this.lst_dsconnection.isSelectionEmpty())return; 
           exito=true; 
            String[] types = {cbx_type.getSelectedItem().toString()};
            try {
                // TODO add your handling code here:
                //determine next card to display
               editDsi = DataStoreManager.dataSourceAdmin.getDataSourceInfo((String) this.lst_dsconnection.getSelectedValue());             
               connection = DriverManager.getConnection(editDsi.getUrl(), editDsi.getUserId(), new String(editDsi.getPassword()));
                } catch (SQLException ex) {                
                exito=false;
            }
           pnl= new PanelDropTarget(pnl_contenedor,connection,this.tre_consulta);
           this.lst_tables.setPanelDropTarget(pnl);
           pnl_contenedor.setBackground(new Color(255,255,255));
           JPanel overAllPanel = new JPanel();
           overAllPanel.setLayout(new BorderLayout());
           overAllPanel.add(pnl_contenedor, BorderLayout.CENTER);
           pnl_contenedor.setBackground(Color.white);
           // here JScrollPane with desktopPane
           JScrollPane scrollPane = new JScrollPane();
           JViewport viewport = new JViewport();
           viewport.setView(pnl_contenedor);
           scrollPane.setViewport(viewport);
           pnl_contenedor.setPreferredSize(new Dimension(800,1000)); //very important          
           overAllPanel.add(scrollPane, BorderLayout.CENTER);
           jSplitPane1.setRightComponent(overAllPanel); 
           }else 
                if(currentDisplayNum==2){
                        modelo =(DefaultTreeModel)tre_consulta.getModel();
                        DefaultMutableTreeNode query=(DefaultMutableTreeNode)modelo.getChild(modelo.getRoot(),1);
                         int j=query.getChildCount();                                              
                        if (j==0)
                        {   
                            cbx_facttables.removeAllItems();
                            this.lst_columsfact.removeAll();
                            DefaultTableModel model=(DefaultTableModel) this.tbl_measures.getModel();
                            int d=model.getRowCount();
                            for(int i=0;i<d-42;i++)
                                model.removeRow(0);
                            this.btn_next.setEnabled(false);
                        }else{
                                cbx_facttables.removeAllItems();
                                for(int i=0;i<j;i++)
                                    { 
                                         cbx_facttables.addItem(query.getChildAt(i).toString());
                                     }

                                this.tbl_measures.setColumnSelectionAllowed(false);
                                if(this.tbl_measures.getRowCount()==42)
                                    this.btn_next.setEnabled(false);
                                factList();
                        }
                        cbx_facttables.updateUI();
                        this.lst_columsfact.updateUI();
                     
                  }else
                         if(currentDisplayNum==3){
                           if(this.tre_dimension.getRowCount()==0)
                           this.btn_next.setEnabled(false);
                           this.lst_fielddimension.removeAll();
                            modelo =(DefaultTreeModel)tre_consulta.getModel();
                            DefaultMutableTreeNode query=(DefaultMutableTreeNode)modelo.getChild(modelo.getRoot(),0);                             
                            int j=query.getChildCount();
                            listmodel1= new DefaultListModel();
                            for(int i=0;i<j;i++)
                            { String medida=tbl_measures.getModel().getValueAt(0,0).toString().substring(0,tbl_measures.getModel().getValueAt(0,0).toString().indexOf(".")-1);
                              String dimension=query.getChildAt(i).toString().substring(0,query.getChildAt(i).toString().indexOf(".")-1);                              
                                if(!medida.equalsIgnoreCase(dimension)) 
                                    listmodel1.addElement(query.getChildAt(i).toString());
                            }
                            this.lst_fielddimension.setModel(listmodel1);   
                            if(j>0)
                            this.lst_fielddimension.setSelectedIndex(0);
                          }
                         else
                             if(currentDisplayNum==4){       
                                        this.txt_reviewcube.setText(txt_cubename.getText());
                                        this.jLabel19.setText(username);
                                        txa_xml.setCaretColor(Color.blue);
                                        txa_xml.setEditable(false);
                                        txa_xml.setFont(new java.awt.Font("Arial", Font.BOLD, 12));
                                        txa_xml.setForeground(new Color(49, 106, 197));
                                        txa_xml.setBackground(Color.white);
                                    String a = "/resources/xmlfiles/";
                                    xml = new CubeSchemaWriter(a, txt_cubename.getText(), tbl_measures, tre_dimension, pnl_contenedor, connection,con,username,editDsi.getUrl().toString());                                   
                                    if(xml.isXMLOk()){
                                        
                                          Serializer serializer = new Serializer(getTextAreaOutputStream(txa_xml));
                                          serializer.setIndent(4);
                                          serializer.setMaxLength(160);
                                          try {
                                             serializer.write(xml.getXmlDocument());  
                                          }
                                          catch (IOException ex) {
                                            System.err.println(ex); 
                                          }  
                                    }else{
                                        txa_xml.setText("Cube Schema can't be created.");
                                    }
                                    
                              }else{
                                         
                                            if(!saveflag){
                                             JFrame mainFrame = MainApp.getApplication().getMainFrame();
                                            demoDialogo4 = new ExitAlert(mainFrame,true);
                                            demoDialogo4.setLocationRelativeTo(mainFrame);
                                            MainApp.getApplication().show(demoDialogo4);         
                                             if(demoDialogo4.getReturnStatus()==1)
                                                dispose();
                                            }
                                            else
                                                dispose();
                                              
                                   }
            updatelist();
            CardLayout cl = (CardLayout) (pnl_main.getLayout());
            String card = String.valueOf(currentDisplayNum + 1);
            if (currentDisplayNum == 1) {
                //need to show second screen
                //enable back button
                btn_back.setEnabled(true);
            } else {
                if (currentDisplayNum == 4) 
                    btn_next.setText("Finish");
               
            }
            //show card
            cl.show(pnl_main, card);
            //update display number//GEN-LAST:event_NextActionPerformed
            currentDisplayNum++;
       
    }                                    

    private void CancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CancelActionPerformed
        // TODO add your handling code here:
        JFrame mainFrame = MainApp.getApplication().getMainFrame();
        demoDialogo4 = new ExitAlert(mainFrame,true);
        demoDialogo4.setLocationRelativeTo(mainFrame);
         MainApp.getApplication().show(demoDialogo4);         
         if(demoDialogo4.getReturnStatus()==1)
            dispose();
       
    }//GEN-LAST:event_CancelActionPerformed
// Step one
    private void btn_addMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_addMouseClicked
        // TODO add your handling code here:
        //Here you can add a new connection
            JFrame mainFrame = MainApp.getApplication().getMainFrame();
            demoDialogo1 = new NewConnection(mainFrame,true);
            demoDialogo1.setLocationRelativeTo(mainFrame);
            MainApp.getApplication().show(demoDialogo1);
            setJNDINames();
    }//GEN-LAST:event_btn_addMouseClicked

private void evn_edit(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_evn_edit
// TODO add your handling code here:
    if(!this.lst_dsconnection.isSelectionEmpty()){
        DataSourceInfo editDsi = null;
        editDsi = DataStoreManager.dataSourceAdmin.getDataSourceInfo((String)this.lst_dsconnection.getSelectedValue());        
        JFrame mainFrame = MainApp.getApplication().getMainFrame();
        demoDialogo1 = new NewConnection(mainFrame,true,editDsi);
        demoDialogo1.setLocationRelativeTo(mainFrame);
        MainApp.getApplication().show(demoDialogo1);
        setJNDINames();
    }
}//GEN-LAST:event_evn_edit

private void evn_remove(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_evn_remove
// TODO add your handling code here:
     removeSelectedJNDIEntries();    
}//GEN-LAST:event_evn_remove
 
     
private void evt_cambiartablas(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_evt_cambiartablas
    // TODO add your handling code here:
   if (exito){
    String[] types = {cbx_type.getSelectedItem().toString()};
   this.lst_tables.setListData(JdbcManager.getTablas(connection,types));
   }
}//GEN-LAST:event_evt_cambiartablas

private void evt_facttables(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_evt_facttables
    // TODO add your handling code here:   
  factList();          
}//GEN-LAST:event_evt_facttables

private void evt_addfact(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_evt_addfact
    // TODO add your handling code here:
    if(!this.lst_columsfact.isSelectionEmpty())
    {   Object [] medida = new Object[4];
        DefaultTableModel model=(DefaultTableModel) this.tbl_measures.getModel();
        medida[0]=this.lst_columsfact.getSelectedValue().toString();
        medida[1]="SUM";
        medida[2]="Standard";
        medida[3]="SUM_"+this.lst_columsfact.getSelectedValue().toString();
        listmodel.remove(lst_columsfact.getSelectedIndex());
        model.insertRow(model.getRowCount()-42,medida);        
        this.btn_next.setEnabled(true);
    }
}//GEN-LAST:event_evt_addfact

private void evt_delfact(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_evt_delfact
    // TODO add your handling code here:
    if(!(this.tbl_measures.getSelectedColumn()==-1)) 
    {   DefaultTableModel model=(DefaultTableModel) this.tbl_measures.getModel();
        model.removeRow(tbl_measures.getSelectedRow());
    }
     DefaultTableModel model=(DefaultTableModel) this.tbl_measures.getModel(); 
   if(model.getRowCount()<=42)
   {    this.btn_next.setEnabled(false);
         modelo =(DefaultTreeModel)tre_consulta.getModel();
                        DefaultMutableTreeNode query=(DefaultMutableTreeNode)modelo.getChild(modelo.getRoot(),1);                        
                        int j=query.getChildCount();
                        int y= cbx_facttables.getItemCount();
                        boolean esta=false;
                        for(int i=0;i<j;i++)
                        {   esta=false; 
                            if(y==0)
                                esta=false;
                            for(int r=0;r<y;r++)
                            {
                                if(cbx_facttables.getItemAt(r).toString().equalsIgnoreCase(query.getChildAt(i).toString()))
                                {esta=true;r=y;
                                }
                            }
                            if(!esta)
                                cbx_facttables.addItem(query.getChildAt(i).toString());
                        }
                        this.tbl_measures.setColumnSelectionAllowed(false);
                        factselected=cbx_facttables.getSelectedItem();
               lst_columsfact.removeAll();
               modelo =(DefaultTreeModel)tre_consulta.getModel();
               DefaultMutableTreeNode query1=(DefaultMutableTreeNode)modelo.getChild(modelo.getRoot(),0);
              j=query1.getChildCount();
               listmodel= new DefaultListModel();
               String name;
               for(int i=0;i<j;i++)
                {    name=getNameFact(query1.getChildAt(i).toString());                     
                    if(name.equalsIgnoreCase(cbx_facttables.getSelectedItem().toString()))
                            listmodel.addElement(cbx_facttables.getSelectedItem().toString()+"."+getCamposFact(query1.getChildAt(i).toString()));
                 }
                 lst_columsfact.setModel(listmodel);    
   }
   else  this.btn_next.setEnabled(true);
}//GEN-LAST:event_evt_delfact

private void evt_listasources(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_evt_listasources
    // TODO add your handling code here:
    resetGUI();
}//GEN-LAST:event_evt_listasources


private void evt_adddimensionlevel(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_evt_adddimensionlevel
    // TODO add your handling code here:
    if(!this.lst_fielddimension.isSelectionEmpty()){
        MyDefaultMutableTreeNode newnode = new MyDefaultMutableTreeNode(this.lst_fielddimension.getSelectedValue().toString(),this.lst_fielddimension.getSelectedValue().toString(),"false");
        DefaultTreeModel  treeModel = (DefaultTreeModel)tre_dimension.getModel();
        TreePath parentPath = tre_dimension.getSelectionPath();
         MyDefaultMutableTreeNode parentNode = null;
         if (parentPath == null) {
            //There is no selection. Default to the root node.
            parentNode = newnode;
          } else {
               parentNode = (MyDefaultMutableTreeNode)(parentPath.getLastPathComponent());
            if(parentNode.isLeaf()&&parentNode.getLevel()>1){              
                treeModel.insertNodeInto(newnode, parentNode,parentNode.getChildCount());
                tre_dimension.scrollPathToVisible(new TreePath(newnode.getPath()));
                tre_dimension.setSelectionPath(new TreePath(newnode.getPath()));
            }
       }
    }

}//GEN-LAST:event_evt_adddimensionlevel

private void evt_deldimensionlevel(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_evt_deldimensionlevel
    // TODO add your handling code here:
        DefaultTableModel model=(DefaultTableModel)tbl_dimensionProperties.getModel();
        Object [] properties= new Object[2];
        DefaultTreeModel  treeModel = (DefaultTreeModel)tre_dimension.getModel();
         TreePath parentPath = tre_dimension.getSelectionPath();
         MyDefaultMutableTreeNode parentNode = null;
         if (parentPath != null) {
             parentNode = (MyDefaultMutableTreeNode)(parentPath.getLastPathComponent());
             treeModel.removeNodeFromParent(parentNode);
             tre_dimension.scrollPathToVisible(new TreePath(parentNode.getPath()));
             tre_dimension.setSelectionPath(new TreePath(parentNode.getPath()));
          } 
         if(treeModel.getChildCount(treeModel.getRoot())>0)
            { this.btn_next.setEnabled(true);}
         else { 
                 this.btn_next.setEnabled(false);
                 model.removeRow(0);model.removeRow(0);model.removeRow(0);
                 properties[0]="";properties[1]=""; model.insertRow(0, properties);
                 properties[0]="";properties[1]=""; model.insertRow(0, properties);
                 properties[0]="";properties[1]=""; model.insertRow(0, properties);
         }
}//GEN-LAST:event_evt_deldimensionlevel

private void btn_adddimension(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_adddimension
    // TODO add your handling code here:
    if(!this.lst_fielddimension.isSelectionEmpty())
    {    
        JFrame mainFrame = MainApp.getApplication().getMainFrame();
        demoDialogo3 = new NameDimension(mainFrame,true);
        demoDialogo3.setLocationRelativeTo(mainFrame);
        demoDialogo3.setNameDimension((String)this.lst_fielddimension.getSelectedValue());
        MainApp.getApplication().show(demoDialogo3);
        if(demoDialogo3.getConfirmation()){
            DefaultTreeModel raiz =(DefaultTreeModel)tre_dimension.getModel();
            DefaultMutableTreeNode query=(DefaultMutableTreeNode)raiz.getRoot();
            MyDefaultMutableTreeNode dimension = new MyDefaultMutableTreeNode(demoDialogo3.getNameDimension(),this.lst_fielddimension.getSelectedValue().toString(),"false");
            MyDefaultMutableTreeNode dimensionc = new MyDefaultMutableTreeNode(this.lst_fielddimension.getSelectedValue().toString(),this.lst_fielddimension.getSelectedValue().toString(),"false");
            MyDefaultMutableTreeNode dimensionc1 = new MyDefaultMutableTreeNode(this.lst_fielddimension.getSelectedValue().toString(),this.lst_fielddimension.getSelectedValue().toString(),"false");
            dimensionc.add(dimensionc1);
            dimension.add(dimensionc);
            raiz.insertNodeInto(dimension,query,query.getChildCount());
            tre_dimension.scrollPathToVisible(new TreePath(dimensionc1.getPath()));
            this.btn_next.setEnabled(true);
        }   
    }    
    
}//GEN-LAST:event_btn_adddimension

private void evt_namecube(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_evt_namecube
      if(evt.getKeyCode()==8)         
      {  if (this.txt_cubename.getText().length()<=1)
                this.btn_next.setEnabled(false);
      }else this.btn_next.setEnabled(true);   
}//GEN-LAST:event_evt_namecube

private void evt_btn_savexml(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_evt_btn_savexml
    // TODO add your handling code here:
    if(this.txt_reviewcube.getText().length()>0){
    if(this.xml.isXMLOk()){
       if(this.btn_private.isSelected()) 
            xml.uploadXML(this.txt_reviewcube.getText(),(DefaultTableModel)this.tbl_access.getModel());
       else
           xml.uploadXML(this.txt_reviewcube.getText());
    if(xml.getFileStorage().isSaved())
    {   saveflag=true;
        this.lbl_cubook.setText("The cube Schema was saved.");
        imagen = createImageIcon("resources/Ok.png");
        this.lbl_ico1.setIcon(imagen);
        this.btn_savexml.setEnabled(false);
        this.btn_back.setEnabled(false);       
        this.btn_cancel.setEnabled(false);
        this.txa_xml.setText("");
        Serializer serializer = new Serializer(getTextAreaOutputStream(txa_xml));
      serializer.setIndent(4);
      serializer.setMaxLength(160);
      try {
         serializer.write(xml.getXmlDocument());  
      }
      catch (IOException ex) {
        System.err.println(ex); 
      } 
    }
    else{
        this.lbl_cubook.setText("Already exist, try with other cube name.");
        imagen = createImageIcon("resources/Error.png");
        this.lbl_ico1.setIcon(imagen);
    }
    }
    }else{
        this.lbl_cubook.setText("Type a Name Cube");
         imagen = createImageIcon("resources/alert.png");
        this.lbl_ico1.setIcon(imagen);
    }
}//GEN-LAST:event_evt_btn_savexml

private void btn_privateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_privateActionPerformed
    // TODO add your handling code here:
      JRadioButton rb=(JRadioButton)evt.getSource();
    if(rb.isSelected())
    {  this.tbl_access.setEnabled(true);
       DefaultTableModel model=(DefaultTableModel) this.tbl_access.getModel();
        AccessCube al=new AccessCube(con,username,model);               
        
    }
    
}//GEN-LAST:event_btn_privateActionPerformed

private void btn_publicActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_publicActionPerformed
    // TODO add your handling code here:
     JRadioButton rb=(JRadioButton)evt.getSource();
    if(rb.isSelected())
    {   DefaultTableModel model=(DefaultTableModel) this.tbl_access.getModel();
       int j=model.getRowCount();
        for(int i=0;i<j;i++)
           model.removeRow(0);
        this.tbl_access.setEnabled(false);
    }
     
    
}//GEN-LAST:event_btn_publicActionPerformed

private void btn_hierarchyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_hierarchyActionPerformed
    // TODO add your handling code here:
      if(!this.lst_fielddimension.isSelectionEmpty()){
        MyDefaultMutableTreeNode newnode = new MyDefaultMutableTreeNode(this.lst_fielddimension.getSelectedValue().toString(),this.lst_fielddimension.getSelectedValue().toString(),"false");
        DefaultTreeModel  treeModel = (DefaultTreeModel)tre_dimension.getModel();
        TreePath parentPath = tre_dimension.getSelectionPath();
         MyDefaultMutableTreeNode parentNode = null;
         if (parentPath == null) {
            //There is no selection. Default to the root node.
            parentNode = newnode;
          } else {
               parentNode = (MyDefaultMutableTreeNode)(parentPath.getLastPathComponent());
            if(parentNode.getLevel()==1){      
                if(parentNode.getUserObject().toString().equalsIgnoreCase(this.lst_fielddimension.getSelectedValue().toString())){
                     newnode = new MyDefaultMutableTreeNode(newnode.getUserObject().toString()+"_"+parentNode.getChildCount(),this.lst_fielddimension.getSelectedValue().toString(),"false");                    
                     MyDefaultMutableTreeNode dimensionc1 = new MyDefaultMutableTreeNode(this.lst_fielddimension.getSelectedValue().toString(),this.lst_fielddimension.getSelectedValue().toString(),"false");
                     newnode.add(dimensionc1);
                    treeModel.insertNodeInto(newnode, parentNode,parentNode.getChildCount());
                    tre_dimension.scrollPathToVisible(new TreePath(dimensionc1.getPath()));
                    tre_dimension.setSelectionPath(new TreePath(dimensionc1.getPath()));
                }
                    else{   MyDefaultMutableTreeNode dimensionc1 = new MyDefaultMutableTreeNode(this.lst_fielddimension.getSelectedValue().toString(),this.lst_fielddimension.getSelectedValue().toString(),"false");
                            newnode.add(dimensionc1);
                            treeModel.insertNodeInto(newnode, parentNode,parentNode.getChildCount());
                            tre_dimension.scrollPathToVisible(new TreePath(dimensionc1.getPath()));
                            tre_dimension.setSelectionPath(new TreePath(dimensionc1.getPath()));
                    }
            }
       }
    }
    
}//GEN-LAST:event_btn_hierarchyActionPerformed

   public void setUserName(String username) {
      this.username=username;
    }

    private void factList() {
       DefaultTableModel model=(DefaultTableModel) this.tbl_measures.getModel(); 
   if(model.getRowCount()>42&&currentDisplayNum==3)
    {  
        JFrame mainFrame = MainApp.getApplication().getMainFrame();
        demoDialogo2 = new FactTableAlert(mainFrame,true);
        demoDialogo2.setLocationRelativeTo(mainFrame);
         MainApp.getApplication().show(demoDialogo2);
         int j=model.getRowCount();
         if(demoDialogo2.getReturnStatus()==1)
         {      this.btn_next.setEnabled(false);
                for(int i=0;i<j-42;i++)
                    model.removeRow(0);
         } else{
                 ComboBoxModel aux=this.cbx_facttables.getModel();
                 aux.setSelectedItem(factselected);
         
         }       
     }  else{
            
               factselected=cbx_facttables.getSelectedItem();               
               lst_columsfact.removeAll();
               modelo =(DefaultTreeModel)tre_consulta.getModel();
               DefaultMutableTreeNode query1=(DefaultMutableTreeNode)modelo.getChild(modelo.getRoot(),0);
               int j=query1.getChildCount();
               listmodel= new DefaultListModel();
               String name;
               lst_columsfact.setModel(listmodel); 
               if(cbx_facttables.getItemCount()>0){
                   for(int i=0;i<j;i++)
                    {    name=getNameFact(query1.getChildAt(i).toString());
                         
                        if(name.equalsIgnoreCase(cbx_facttables.getSelectedItem().toString()))
                                listmodel.addElement(cbx_facttables.getSelectedItem().toString()+"."+getCamposFact(query1.getChildAt(i).toString()));
                     }
                     lst_columsfact.setModel(listmodel); 
               }
     }
    }  
public void setJNDINames()
    {   final DataStoreManager dataMgr = DataStoreManager.getDataStoreManager();
        @SuppressWarnings("static-access")
        Map dsMap = dataMgr.dataSourceAdmin.listDataSources();
        Iterator keySetIterator = dsMap.keySet().iterator();
        String jndiNames[] = new String[dsMap.size()];
        for(int i = 0; keySetIterator.hasNext(); i++)
        {   String key = (String)keySetIterator.next();
            DataSourceInfo dsi = (DataSourceInfo)dsMap.get(key);
            jndiNames[i] = dsi.getName();
        }
         lst_dsconnection.setListData(jndiNames);
    }
    
     public void removeSelectedJNDIEntries()
    {
         DataStoreManager.dataSourceAdmin.deleteDataSource((String)this.lst_dsconnection.getSelectedValue());
         this.lst_dsconnection.removeAll();
         setJNDINames();
    }
private void updatelist(){
      String[] types = {cbx_type.getSelectedItem().toString()};
      JPanel sourcePanel;
      jPanel6.removeAll();
      DefaultListModel sourceModel = new DefaultListModel();
      Vector v=null;
      v=JdbcManager.getTablas(connection, types);
      for(int i=0; i<v.size(); i++){           
            sourceModel.addElement(v.elementAt(i));
        }
    // gets the panel with the List and a heading for the List
    sourcePanel = getListPanel(lst_tables, "Star Model", sourceModel); 
    jPanel6.add( sourcePanel );
 }
// Step two  
 private JPanel getListPanel(DNDList list, String labelName, DefaultListModel listModel ){  
        JPanel listPanel = new JPanel();
        JScrollPane scrollPane = new JScrollPane(list);
        
        list.setModel(listModel);   
        JLabel nameListName = new JLabel(labelName );
        
        listPanel.setLayout( new BorderLayout());
        listPanel.add(nameListName, BorderLayout.NORTH);
        listPanel.add( scrollPane, BorderLayout.CENTER);
        listPanel.setSize(150,400);
        return listPanel;     
  }
 
  public ImageIcon createImageIcon(String path,String description) {
    java.net.URL imgURL = getClass().getResource(path);
    if (imgURL != null) {
        return new ImageIcon(imgURL, description);
    } else {        
        return null;
    }
  }
   public String    getCamposFact(String name){
        String aux ="";
        boolean band=false;
            for(int i=0;i<name.length();i++){
               if(name.charAt(i)=='.')
               { band=true;i++;}
               if (band)
                aux=aux+""+name.charAt(i);
           }        
        return aux;
    }
    public String   getNameFact(String name){
        String aux ="";
            for(int i=0;i<name.length();i++){
               if(name.charAt(i)=='.')
                   break;
                aux=aux+""+name.charAt(i);
           }        
        return aux;
    }
    /**
     * @param args the command line arguments
     */
    public void resetGUI()
    {   lst_tables = new DNDList();
         pnl_contenedor=new MyJDesktopPane(dndListener,tre_consulta);         
         DefaultTreeModel modelo =(DefaultTreeModel)tre_consulta.getModel();
         DefaultMutableTreeNode query=(DefaultMutableTreeNode)modelo.getChild(modelo.getRoot(),1);         
         query.removeAllChildren();
         query=null;         
         query=(DefaultMutableTreeNode)modelo.getChild(modelo.getRoot(),0);
         query.removeAllChildren();
         query=null;
         tre_consulta.updateUI();
         DefaultTreeModel  treeModel = (DefaultTreeModel)tre_dimension.getModel();
         ((MyDefaultMutableTreeNode)treeModel.getRoot()).removeAllChildren();    
         tre_dimension.updateUI();
         this.cbx_facttables.removeAllItems();
         this.lst_columsfact.removeAll();
         this.lst_tables.removeAll();
         this.three=false;
         DefaultTableModel model=(DefaultTableModel) this.tbl_measures.getModel();
         int j=model.getRowCount();
          for(int i=0;i<j-42;i++)
                    model.removeRow(0);
    
         
    }
    public OutputStream getTextAreaOutputStream(final JTextArea t)
    { return new OutputStream()
       { JTextArea ta = t;
         public void write(int b) //minimum implementation of an OutputStream
          { byte[] bs = new byte[1]; bs[0] = (byte) b;
            ta.append(new String(bs));
          }//write
       };//OutputStream
    }
  private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = MainApp.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btn_add;
    private javax.swing.JButton btn_adddimension;
    private javax.swing.JButton btn_addfact;
    private javax.swing.JButton btn_addfact1;
    private javax.swing.JButton btn_back;
    private javax.swing.JButton btn_cancel;
    private javax.swing.JButton btn_delfact;
    private javax.swing.JButton btn_delfact1;
    private javax.swing.JButton btn_edit;
    private javax.swing.JButton btn_hierarchy;
    private javax.swing.JButton btn_next;
    private javax.swing.JRadioButton btn_private;
    private javax.swing.JRadioButton btn_public;
    private javax.swing.JButton btn_remove;
    private javax.swing.JButton btn_savexml;
    private javax.swing.ButtonGroup btng_access;
    private javax.swing.JComboBox cbx_facttables;
    private javax.swing.JComboBox cbx_type;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JScrollPane jScrollPane8;
    private javax.swing.JScrollPane jScrollPane9;
    private javax.swing.JSeparator jSeparator5;
    private javax.swing.JSeparator jSeparator8;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JSplitPane jSplitPane2;
    private org.jdesktop.swingx.JXTaskPane jXTaskPane1;
    private javax.swing.JScrollPane jsc_table;
    private javax.swing.JSeparator jsp_main;
    private javax.swing.JTabbedPane jtp_resumen;
    private javax.swing.JLabel lbl_cubook;
    private javax.swing.JLabel lbl_ico1;
    private javax.swing.JList lst_columsfact;
    private javax.swing.JList lst_dsconnection;
    private javax.swing.JList lst_fielddimension;
    private javax.swing.JPanel pnl_access;
    private javax.swing.JPanel pnl_main;
    private javax.swing.JPanel pnl_reviewcube;
    private javax.swing.JPanel pnl_savecube;
    private javax.swing.JPanel pnl_step1;
    private javax.swing.JPanel pnl_step2;
    private javax.swing.JPanel pnl_step3;
    private javax.swing.JPanel pnl_step4;
    private javax.swing.JPanel pnl_step5;
    private javax.swing.JTable tbl_access;
    private javax.swing.JTable tbl_dimensionProperties;
    private javax.swing.JTable tbl_measures;
    public JComboBox      format;
    public        JComboBox  aggregator;
    private javax.swing.JTree tre_consulta;
    private javax.swing.JTree tre_dimension;
    private javax.swing.JTextArea txa_xml;
    private javax.swing.JTextField txt_cubename;
    private javax.swing.JTextField txt_reviewcube;
    // End of variables declaration//GEN-END:variables
   private int currentDisplayNum = 1;
   private NewConnection demoDialogo1;
   private FactTableAlert demoDialogo2;   
   private NameDimension demoDialogo3;
   private ExitAlert demoDialogo4;
   public  JComboBox  Boolean;
   
}
