
 
package WorkSpace.Dice;

import java.util.*;
import javax.swing.tree.*;
import org.olap4j.metadata.*;

public class CheckNode extends DefaultMutableTreeNode {

  public final static int SINGLE_SELECTION = 0;
  public final static int DIG_IN_SELECTION = 4;
  protected int selectionMode;
  protected boolean isSelected=false;
  boolean hierarchy =false;
   boolean     cube=false;
   boolean     dimension=false;
   boolean     member=false;
   boolean     level=false;
   Hierarchy a;
   Cube b;
   Dimension c;
   Member d;
   Level ee;

  public CheckNode(Object nodeSpecifier) {  
      this.setUserObject((nodeSpecifier));
        try {
               a = (Hierarchy) nodeSpecifier.getClass().cast(nodeSpecifier);
               this.setUserObject(a.getName());
               hierarchy=true;               
            } catch( Exception e ) {
             try {
                     b = (Cube)  nodeSpecifier.getClass().cast(nodeSpecifier);
                     this.setUserObject(b.getName());
                     cube=true;
                } catch( Exception e1 ) {
                     try {
                             c = (Dimension)  nodeSpecifier.getClass().cast(nodeSpecifier);
                             this.setUserObject(c.getName());                             
                             dimension=true;
                             
                          } catch( Exception e2 ) {
                             try{
                                     d = (Member)  nodeSpecifier.getClass().cast(nodeSpecifier);
                                     this.setUserObject(d.getName());                             
                                     member=true;
                             }  catch( Exception e3 ) {
                               try{
                                     ee =  (Level) nodeSpecifier.getClass().cast(nodeSpecifier);
                                     this.setUserObject(ee.getName());                             
                                     level=true;
                              }catch( Exception e4 ) {
                                   
                              }
                             }
                             
                          }
                 }
            }   
       
  }

  public CheckNode(Object userObject, boolean allowsChildren
                                    , boolean isSelected) {
    super(userObject, allowsChildren);
    this.isSelected = isSelected;
    setSelectionMode(DIG_IN_SELECTION);
  }


  public void setSelectionMode(int mode) {
    selectionMode = mode;
  }

  public int getSelectionMode() {
    return selectionMode;
  }

  public void setSelected(boolean isSelected) {
    this.isSelected = isSelected;
    
    if ((selectionMode == DIG_IN_SELECTION)
        && (children != null)) {        
      Enumeration  enume = children.elements();      
      while (enume.hasMoreElements()) {
        CheckNode node = (CheckNode)enume.nextElement();
        node.setSelected(isSelected);
      }
    }
  }
  
  public boolean isSelected() {
    return isSelected;
  }
  public boolean isMember(){
  return member;
  }
  public Member getMember(){
  return d;
  }
  public Dimension getDimension(){
  return c;
  }


  // If you want to change "isSelected" by CellEditor,
  /*
  public void setUserObject(Object obj) {
    if (obj instanceof Boolean) {
      setSelected(((Boolean)obj).booleanValue());
    } else {
      super.setUserObject(obj);
    }
  }
  */

}


