/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package WorkSpace.Dice;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;
/**
 *
 * @author Alexander
 */
public class NodeSelectionListener extends MouseAdapter {
    JTree tree;    
   public  NodeSelectionListener(JTree tree) {
      this.tree = tree;
   }   
    @Override
    public void mouseClicked(MouseEvent e) {
      int x = e.getX();
      int y = e.getY();
      int row = tree.getRowForLocation(x, y);
      TreePath  path = tree.getPathForRow(row);
      if (path != null) { 
        selection(path);
        CheckNode node = (CheckNode)path.getLastPathComponent();
        if(node.getLevel()>3)
        {   boolean isSelected = ! (node.isSelected());
            node.setSelected(isSelected);
        }
        ((DefaultTreeModel)tree.getModel()).nodeChanged(node);
        // I need revalidate if node is root.  but why?
        if (row == 0) {
          tree.revalidate();
          tree.repaint();
        }
      }
    }

    private void selection(TreePath path) {
        CheckNode node = (CheckNode)path.getLastPathComponent();
        CheckNode nodep=node;       
        if(nodep.getLevel()!=0){
            while(nodep.getLevel()!=1)
            { nodep=(CheckNode)nodep.getParent();
            }
            selectionR(nodep);
            tree.revalidate();
            tree.repaint();
        }
    }

    private void selectionR(CheckNode nodep) {        
        CheckNode child;             
        nodep.setSelected(false);
        for(int i=0; i<nodep.getChildCount();i++) {
            child =(CheckNode) nodep.getChildAt(i);
            nodep.setSelected(false);
            if (child.getChildCount()>0)
                selectionR(child);
            else
                child.setSelected(false);             
        }
    }
  }