package misc.swing.border;



import java.util.Iterator;

import org.jdom.Element;

public class BordersXMl {
	public static final String KEY_BORDERS_INFO="BordersInfo";

	private BordersXMl(){		
	}
	public static final Element build(BordersInfo bordersInfo){
		return new BordersXMl().getElement(bordersInfo);
	}
	public static final BordersInfo build(Element eBorders){
		return new BordersXMl().getBorders(eBorders);
	}
	private BordersInfo getBorders(Element eBorders) {
		BordersInfo bordersInfo=new BordersInfo();
		if(eBorders!=null && KEY_BORDERS_INFO.equals(eBorders.getName().trim())){
			Iterator<?> it=eBorders.getChildren(
					BorderInfoXML.KEY_BORDER_INFO).iterator();
			while(it.hasNext()){
				Element eBorde=(Element) it.next();
				BorderInfo borderInfo=BorderInfoXML.build(eBorde);
				if(borderInfo!=null){
					bordersInfo.add(borderInfo);
				}else{
					System.err.println("Failed loading BorderInfo");
				}
			}
		}
		return bordersInfo;
	}
	private Element getElement(BordersInfo bordersInfo) {
		Element eBorders=new Element(KEY_BORDERS_INFO);
		for(int i=0; i<bordersInfo.size(); i++){
			BorderInfo borderInfo=bordersInfo.get(i);
			eBorders.addContent(BorderInfoXML.build(borderInfo));			
		}
		return eBorders;
	}
	
}
