package misc.swing.border.ui;


import java.awt.Component;

import javax.swing.DefaultListCellRenderer;
import javax.swing.JLabel;
import javax.swing.JList;
import misc.swing.border.BorderInfo;




/**
*
* @author  f00992x
*/
public class ListCellRenderer extends DefaultListCellRenderer {
	private static final long serialVersionUID = 1L;

	public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
		JLabel label=(JLabel) super.getListCellRendererComponent(
				list, value, index, isSelected,	cellHasFocus);
		if(value instanceof BorderInfo){
			label.setText(((BorderInfo)value).getName());
		}
		return label;
	}

}
