package misc.swing.combofont;

import java.awt.Component;
import java.awt.Font;

import javax.swing.DefaultListCellRenderer;
import javax.swing.JList;

public class FontNameCellRender extends DefaultListCellRenderer{
	private static final long serialVersionUID = 1L;
	
	
	public FontNameCellRender() {
		super();
		
	}

	@Override
	public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
      String sValue=(value!=null)? value.toString():"";
    	if(value instanceof Font){
    		sValue=((Font) value).getFontName();
    	}
    	Component render = super.getListCellRendererComponent(list, sValue, index, isSelected,
				cellHasFocus);
    	if(value instanceof Font){
    		render.setFont((Font) value);
    	}
    	return render;
	}

}//End class ComboFontCellRender

