package misc.swing.combofont;


import java.awt.Font;
import java.awt.GraphicsEnvironment;

import javax.swing.DefaultComboBoxModel;

public class FontNameModel extends DefaultComboBoxModel {
	private static final long serialVersionUID = 1L;

	public FontNameModel() {
		String[] names=GraphicsEnvironment.getLocalGraphicsEnvironment()
			.getAvailableFontFamilyNames();
		for(int i=0; i<names.length; i++){
			addElement(new Font(names[i], Font.PLAIN,11));
		}
	}
}
