package misc.swing.combofont;


import javax.swing.DefaultComboBoxModel;
import javax.swing.JLabel;

public class HorizontalAlignmentModel extends DefaultComboBoxModel {
	private static final long serialVersionUID = 1L;

	public HorizontalAlignmentModel() {
		Integer[] textOrientations= new Integer[5];
		textOrientations[0]=new Integer(JLabel.RIGHT);
		textOrientations[1]=new Integer(JLabel.LEFT);
		textOrientations[2]=new Integer(JLabel.LEADING);
		textOrientations[3]=new Integer(JLabel.TRAILING);		
		textOrientations[4]=new Integer(JLabel.CENTER);		
		for(int i=0; i<textOrientations.length; i++){
			addElement(textOrientations[i]);
		}		
	}
}
