package misc.swing.table;



import javax.swing.table.TableModel;


public class ArraySpanModel extends DefaultSpanModel {
	
	
	public ArraySpanModel() {
		super(new ArrayTableModel());
	}
	public ArraySpanModel(ArrayTableModel tableModel) {
		super(tableModel);
	}
	public void setSize(int rows, int columns){
		spans = new Span[rows][columns];
		((ArrayTableModel)tableModel).setSize(rows, columns);
		iniSpan();

	}
	public void setTableModel(TableModel tm){
		if(tm instanceof ArrayTableModel) {
			super.setTableModel(tm);
			
		}else{
			throw new UnsupportedOperationException();
		}
	}

}
