package misc.swing.table.settings;




public class StylesFactory {

	public static Styles createDefaultStyles(){
		Styles styles= new Styles();
		styles.add(StyleFactory.createStyleEven());
		styles.add(StyleFactory.createStyleGelb());
		styles.add(StyleFactory.createStyleGreen());
		styles.add(StyleFactory.createStyleGruen());
		styles.add(StyleFactory.createStyleOdd());
		styles.add(StyleFactory.createStyleRed());
		styles.add(StyleFactory.createStyleRot());
		styles.add(StyleFactory.createStyleSpan() );
		styles.add(StyleFactory.createStyleYellow());
		return styles;
	}
	public static Styles createDefaultHeaderStyles(){
		Styles styles= new Styles();
		styles.add(StyleFactory.createHeaderStyleEven());
		styles.add(StyleFactory.createHeaderStyleGelb());
		styles.add(StyleFactory.createHeaderStyleGreen());
		styles.add(StyleFactory.createHeaderStyleGruen());
		styles.add(StyleFactory.createHeaderStyleOdd());
		styles.add(StyleFactory.createHeaderStyleRed());
		styles.add(StyleFactory.createHeaderStyleRot());
		styles.add(StyleFactory.createHeaderStyleSpan() );
		styles.add(StyleFactory.createHeaderStyleYellow());
		
		return styles;
	}
	public static Styles createDefaultRowHeaderStyles(){
		Styles styles= new Styles();
		styles.add(StyleFactory.createRowHeaderStyleEven());
		styles.add(StyleFactory.createRowHeaderStyleGelb());
		styles.add(StyleFactory.createRowHeaderStyleGreen());
		styles.add(StyleFactory.createRowHeaderStyleGruen());
		styles.add(StyleFactory.createRowHeaderStyleOdd());
		styles.add(StyleFactory.createRowHeaderStyleRed());
		styles.add(StyleFactory.createRowHeaderStyleRot());
		styles.add(StyleFactory.createRowHeaderStyleSpan() );
		styles.add(StyleFactory.createRowHeaderStyleYellow());
		
		return styles;
	}
}
