package misc.util;



import java.io.File;

public class Util {

	public static String getRelativePath(File file, File fParent){
		String result=file.getAbsolutePath();
		String rFParent=fParent.getAbsolutePath();
		if(result.startsWith(rFParent)){
			result =result.substring(rFParent.length());
			result=replaceAll(result, "\\", "/");
			if(result.startsWith("/")){
				result=result.substring(1);
			}
		}		
		return result;
	}
	public static String replaceAll(final String source, final String mark, 
            final String toMark) {		
        String result = source;
        int p = 0;
        while (source!=null && mark!=null && toMark!=null) {
            p = result.indexOf(mark, p);
            if (p == -1) {
                break;
            }
            result = result.substring(0, p) + toMark
                + result.substring(p + mark.length());
            p += toMark.length();
        }
        return result;
    }
	
}
