/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Core.CubeConfiguration;

/**
 *
 * @author Alexander
 */
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import javax.swing.table.DefaultTableModel;
 
public class FileStorage
{       Connection con = null;
        PreparedStatement ps = null;
        ResultSet rs = null;
        String path;
        String cubeName;
        String username;
        java.sql.Date date;
        String url;
        boolean saved=false;
         DefaultTableModel model= new DefaultTableModel();
        
        public FileStorage(Connection con,String path,String cubeName,String username,String url){
            this.con=con;
            this.url=url;            
            this.cubeName=cubeName;
            this.username=username;
            this.path=path;            
            saveFilePublic();          
        }

 public FileStorage(Connection con, String path, String cubeName, String username, String url, DefaultTableModel model) {
            this.con=con;
            this.url=url;            
            this.cubeName=cubeName;
            this.username=username;
            this.path=path; 
            this.model=model;
            saveFilePrivate();
    }
 private File getFile() {
    File xmlfile = new File(System.getProperty("user.dir"));
    String xmlpath = xmlfile.getAbsolutePath() + "/resources/xmlfiles/";
    File xmlpathfile = new File(xmlpath);
    File jdbcFile = new File(xmlpathfile.getAbsolutePath() + "/" + path);
    System.out.println(xmlpathfile.getAbsolutePath() + "/" + path);
    return jdbcFile;
  }
	public void saveFilePublic()
	{   try
		{      byte[] fileBytes = getBytesFromFile(getFile()); 
                        ps = con.prepareStatement("INSERT INTO xml(fecha,rolname,nombrexml,source,url,access) VALUES(?,?,?,?,?,?)");
                        date=getCurrentJavaSqlDate();
                        ps.setDate(1, date);
                        ps.setString(2,username);
                        ps.setString(3,cubeName);                        
                        ps.setBytes(4, fileBytes); 
                        ps.setString(5,url);
                        ps.setString(6,"1");
			ps.executeUpdate();
                        saved=true;
		}
		catch (Exception e){		
		}
		
	}
        public void saveFilePrivate()
	{   try
		{       byte[] fileBytes = getBytesFromFile(getFile()); 
                        ps = con.prepareStatement("INSERT INTO xml(fecha,rolname,nombrexml,source,url,access) VALUES(?,?,?,?,?,?)");
                        date=getCurrentJavaSqlDate();
                        ps.setDate(1, date);
                        ps.setString(2,username);
                        ps.setString(3,cubeName);                        
                        ps.setBytes(4, fileBytes); 
                        ps.setString(5,url);
                        ps.setString(6,"0");
			ps.executeUpdate();
                        for(int i=0;i<model.getRowCount();i++)
                        {  
                           if(model.getValueAt(i,1).toString().equalsIgnoreCase("true"))
                           {   
                            ps = con.prepareStatement("INSERT INTO cube(nombrexml,rolname,rolshare) VALUES(?,?,?)");                          
                            ps.setString(1, cubeName);
                            ps.setString(2,username);
                            ps.setString(3,model.getValueAt(i,0).toString());                        
                            ps.executeUpdate();
                           }
                        }
                        saved=true;
		}
		catch (Exception e){
                    e.printStackTrace();
		}
		
	}
 
	public static byte[] getBytesFromFile(File file) throws IOException
	{
		InputStream is = new FileInputStream(file); 
		// Get the size of the file
		long length = file.length(); 
		if (length > Integer.MAX_VALUE)
		{
			// File is too large
		}
 
		// Create the byte array to hold the data
		byte[] bytes = new byte[(int) length]; 
		// Read in the bytes
		int offset = 0;
		int numRead = 0;
		while (offset < bytes.length && (numRead = is.read(bytes, offset, bytes.length - offset)) >= 0)
		{
			offset += numRead;
		}
 
		// Ensure all the bytes have been read in
		if (offset < bytes.length)
		{
			throw new IOException("Could not completely read file " + file.getName());
		}
 
		// Close the input stream and return bytes
		is.close();
		return bytes;
	}
         public  java.sql.Date getCurrentJavaSqlDate() {
                 java.util.Date today = new java.util.Date();
                 return new java.sql.Date(today.getTime());
         }
         public boolean isSaved(){
            return saved;
         }
 
}

