package Core.queryMDX;
import Core.tree.TreeMain;
import java.util.Vector;
import org.olap4j.metadata.Member;

/**
 *
 * @author Ricardo
 */
public class Rows {
    QueryAxis queryAxis;
    TreeMain tree;
    boolean bandera=true;
      public Rows(Vector createMembers, Vector createDimensions) {
        //Primero se crea el arbol correspondiente a este eje
        //segundo se envia el modelo del arbol a QueryAxis para que realice la respectiva consulta de este arbol                  
        this.tree=new TreeMain(createMembers,createDimensions);                
        this.queryAxis=new QueryAxis(this.tree.getModelo());        
    }
      public void DrillDown_RollUp(int dimension,int member){
        this.tree.drillDown_RollUp(dimension, member);
        this.bandera=this.tree.getBandera();
        if(this.bandera){        
            this.queryAxis=new QueryAxis(this.tree.getModelo());           
        }
    }      
    public boolean getBandera(){
        return this.bandera;
    }      
    public String getQuexyAxis(){
        return queryAxis.getQueryAxis();
    }
    public TreeMain getTreeMain(){
        return this.tree;
    }
    public void setTreeMain(TreeMain tree){//este metodo solo es valido para el pivot
        this.tree=tree;
        this.queryAxis=new QueryAxis(this.tree.getModelo());        
    }           
    public Vector getVectorHierarchies(){
        return this.tree.getVectorHierarchy();
    }

   public void addMeasure(Member measure) {
        this.tree.addMeasure(measure);
        this.queryAxis=new QueryAxis(this.tree.getModelo());
    }

    public void deleteMeasure(Member measure) {
        this.tree.deleteMeasure(measure);
        this.queryAxis=new QueryAxis(this.tree.getModelo());
    }

    public void deleteMember(int dimension, int member) {
        this.tree.deleteMember(dimension, member);
        this.bandera=this.tree.getBandera();
        if(this.bandera){        
            this.queryAxis=new QueryAxis(this.tree.getModelo());           
        }        
    }
    
    public void setVectorMain(Vector vectorMain) {
        this.tree.setVectorMain(vectorMain);
    }
    
}
