/*
 * MyCubes.java
 *
 * Created on 10 de enero de 2009, 22:02
 */

package WorkSpace.Cube;
import Core.ManagerCube.Manager;
import WorkSpace.CubeConfiguration.ExitAlert;
import WorkSpace.Navigator.NavigatorArbol;
import WorkSpace.MainApp;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Date;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.ListSelectionModel;
import javax.swing.table.DefaultTableModel;
import org.noos.xing.mydoggy.ToolWindow;
/**
 *
 * @author  Alexander
 */
public class MyCubes extends javax.swing.JPanel {
   Connection con = null;
     PreparedStatement ps = null;
     PreparedStatement ps1 = null;
     ResultSet rs = null;
     ToolWindow toolWindow;
     JPanel pane;
     DefaultTableModel model;
     String url;     
     JPanel paneG;
     Manager manager;
     String username;
     ImageIcon imagen;
     String cubename;  
     String fullpath;

    public MyCubes(Connection con, ToolWindow toolWindow, JPanel pane, Manager manager,String username) {
         initComponents();
         this.tbl_cubeinfo.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
         this.con=con;         
         this.pane=pane;
         this.toolWindow=toolWindow;               
         this.manager=manager;               
         this.username=username;               
         btn_opencube.setText("Open Cube");
         btn_del.setText("Delete Cube");
         btn_update.setText("Update");        
         listcubes();
    }

  
     private void deletecube() {
        int j=this.tbl_cubeinfo.getSelectedRow();        
        if(j!=-1){
              if(username.equalsIgnoreCase(model.getValueAt(j, 1).toString()))
              {
                    try
                    {                    
                       ps = con.prepareStatement("DELETE FROM xml WHERE rolname=? and nombrexml=?");
                       cubename=model.getValueAt(j, 0).toString();
                       ps.setString(1,model.getValueAt(j, 1).toString());
                       ps.setString(2,model.getValueAt(j, 0).toString()); 
                       ps.executeUpdate();
                       ps = con.prepareStatement("DELETE FROM cube WHERE rolname=? and nombrexml=?");
                       ps.setString(1,model.getValueAt(j, 1).toString());
                       ps.setString(2,model.getValueAt(j, 0).toString()); 
                       ps.executeUpdate();
                       imagen =createImageIcon("resources/Ok.png");
                       this.lbl_icono1.setIcon(imagen);
                       this.lbl_message.setText("The Cube "+cubename+" has been deleted");
                       listcubes();                   
                    }
                    catch (Exception e)
                    {// TODO Auto-generated catch block
                           System.out.println("No se pudo borrar el cubo "+cubename);
                           manager.getStatusB().setText("Can't delete Cube "+cubename);
                    }
              }
             
        }
		
    }
         private void listcubes() {
             
             String rolname,nombrexml;
             Date fecha;
             Object [] medida = new Object[3];   
             model =(DefaultTableModel) this.tbl_cubeinfo.getModel();  
             int j=tbl_cubeinfo.getRowCount();
            for(int i=0;i<j;i++)
             {   model.removeRow(0);
             } 
             if(this.cbx_typeCube.getSelectedIndex()==0)
                { try{
                           ps = con.prepareStatement("select * from xml where rolname=?");
                           ps.setString(1,username);
                            rs = ps.executeQuery();
                            while (rs.next())
                            {
                                  rolname = rs.getString("rolname");
                                  nombrexml=rs.getString("nombrexml");
                                  fecha=rs.getDate("fecha");                              
                                  medida[0]=nombrexml;
                                  medida[1]=rolname;
                                  medida[2]=fecha.toString(); 
                                  model.insertRow(model.getRowCount(),medida);                              
                            }    

                            }                      
                            catch (SQLException sqlException)
                            {
                                    sqlException.printStackTrace();
                            }
                            catch (Exception exception)
                            {
                                    exception.printStackTrace();
                            } 
             }else{
              
                      try{
                           ps = con.prepareStatement("select * from xml where access=? and rolname!=?");
                           ps.setString(1,"1");
                            ps.setString(2,username);
                            rs = ps.executeQuery();
                            while (rs.next())
                            {
                                  rolname = rs.getString("rolname");
                                  nombrexml=rs.getString("nombrexml");
                                  fecha=rs.getDate("fecha");                              
                                  medida[0]=nombrexml;
                                  medida[1]=rolname;
                                  medida[2]=fecha.toString(); 
                                  model.insertRow(model.getRowCount(),medida);                              
                            }    
                          
                           ps = con.prepareStatement("select * from xml,cube where xml.nombrexml=cube.nombrexml " +
                                   "and access=? and rolshare=?");
                           ps.setString(1,"0");
                            ps.setString(2,username);
                            rs = ps.executeQuery();
                            
                            while (rs.next())
                            {
                                  rolname = rs.getString("rolname");
                                  nombrexml=rs.getString("nombrexml");
                                  fecha=rs.getDate("fecha");                              
                                  medida[0]=nombrexml;
                                  medida[1]=rolname;
                                  medida[2]=fecha; 
                                  model.insertRow(model.getRowCount(),medida);                              
                            }    

                            }                      
                            catch (SQLException sqlException)
                            {
                                    sqlException.printStackTrace();
                            }
                            catch (Exception exception)
                            {
                                    exception.printStackTrace();
                            } 
                 }             
    }
      public void downloadFile(int i)
	{ 
            
            try
		{                    
			ps = con.prepareStatement("SELECT source,url FROM xml WHERE rolname=? and nombrexml=?");
                      ps.setString(1,model.getValueAt(i, 1).toString());
                        ps.setString(2,model.getValueAt(i, 0).toString()); 
			rs = ps.executeQuery();
 
			if (rs.next())
			{				
				byte[] fileBytes = rs.getBytes("source"); 				
				OutputStream os = new FileOutputStream(getFile(i));
				os.write(fileBytes); 
				os.close();
                                url=rs.getString("url");
			}
 
		}
		catch (Exception e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
   private File getFile(int i) {
    File xmlfile = new File(System.getProperty("user.dir"));
    String xmlpath = xmlfile.getAbsolutePath() + "/resources/xmlfiles/";
    File xmlpathfile = new File(xmlpath);
    fullpath=xmlpathfile.getAbsolutePath() + "/" + model.getValueAt(i, 0).toString()+".xml";
    File jdbcFile = null;
    if (!(xmlpathfile.exists()))
      try {
        xmlpathfile.mkdirs();
        jdbcFile = new File(fullpath);
        jdbcFile.createNewFile();
      } catch (IOException ex) {
        ex.printStackTrace();
      }

    else
      jdbcFile = new File(fullpath);
    return jdbcFile;
  }
 
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        cbx_typeCube = new javax.swing.JComboBox();
        jScrollPane1 = new javax.swing.JScrollPane();
        tbl_cubeinfo = new javax.swing.JTable();
        btn_opencube = new javax.swing.JButton();
        btn_del = new javax.swing.JButton();
        btn_update = new javax.swing.JButton();
        lbl_icono = new javax.swing.JLabel();
        lbl_icono1 = new javax.swing.JLabel();
        lbl_message = new javax.swing.JLabel();

        setName("Form"); // NOI18N

        cbx_typeCube.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "My Cubes", "Shared Cubes" }));
        cbx_typeCube.setName("cbx_typeCube"); // NOI18N
        cbx_typeCube.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                cbx_typeCubeItemStateChanged(evt);
            }
        });

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        tbl_cubeinfo.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Cube Name", "Owner", "Date"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tbl_cubeinfo.setName("tbl_cubeinfo"); // NOI18N
        tbl_cubeinfo.getTableHeader().setReorderingAllowed(false);
        jScrollPane1.setViewportView(tbl_cubeinfo);
        tbl_cubeinfo.getColumnModel().getColumn(0).setResizable(false);
        tbl_cubeinfo.getColumnModel().getColumn(1).setResizable(false);
        tbl_cubeinfo.getColumnModel().getColumn(2).setResizable(false);

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(WorkSpace.MainApp.class).getContext().getResourceMap(MyCubes.class);
        btn_opencube.setText(resourceMap.getString("btn_opencube.text")); // NOI18N
        btn_opencube.setName("btn_opencube"); // NOI18N
        btn_opencube.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_opencubeActionPerformed(evt);
            }
        });

        btn_del.setText(resourceMap.getString("btn_del.text")); // NOI18N
        btn_del.setName("btn_del"); // NOI18N
        btn_del.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_delActionPerformed(evt);
            }
        });

        btn_update.setText(resourceMap.getString("btn_update.text")); // NOI18N
        btn_update.setName("btn_update"); // NOI18N
        btn_update.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_updateActionPerformed(evt);
            }
        });

        lbl_icono.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lbl_icono.setIcon(resourceMap.getIcon("lbl_icono.icon")); // NOI18N
        lbl_icono.setText(resourceMap.getString("lbl_icono.text")); // NOI18N
        lbl_icono.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        lbl_icono.setName("lbl_icono"); // NOI18N

        lbl_icono1.setText(resourceMap.getString("lbl_icono1.text")); // NOI18N
        lbl_icono1.setName("lbl_icono1"); // NOI18N

        lbl_message.setText(resourceMap.getString("lbl_message.text")); // NOI18N
        lbl_message.setName("lbl_message"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                .addComponent(btn_opencube)
                                .addGap(15, 15, 15)
                                .addComponent(btn_del)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(btn_update, javax.swing.GroupLayout.DEFAULT_SIZE, 84, Short.MAX_VALUE))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                .addComponent(lbl_icono1, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(lbl_message, javax.swing.GroupLayout.DEFAULT_SIZE, 169, Short.MAX_VALUE))))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(92, 92, 92)
                        .addComponent(cbx_typeCube, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 237, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(65, 65, 65)
                        .addComponent(lbl_icono, javax.swing.GroupLayout.PREFERRED_SIZE, 130, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(16, 16, 16)
                .addComponent(cbx_typeCube, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 221, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btn_opencube)
                    .addComponent(btn_del)
                    .addComponent(btn_update))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lbl_icono1, javax.swing.GroupLayout.PREFERRED_SIZE, 59, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lbl_message, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(lbl_icono, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(119, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btn_opencubeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_opencubeActionPerformed
        // TODO add your handling code here:
        boolean flag=false;
        for(int i=0;i<tbl_cubeinfo.getRowCount();i++)
             {   if(tbl_cubeinfo.isRowSelected(i)){
                    downloadFile(i);   
                    manager.setCubeName(model.getValueAt(i, 0).toString());
                    NavigatorArbol panelnavigator=new NavigatorArbol(fullpath,"admin","admin",url,manager) ;
                    pane.removeAll();
                    pane.add(panelnavigator.getPanel());            
                    toolWindow.setActive(true); 
                    this.lbl_message.setText("");
                    this.lbl_icono1.setIcon(null);                  
                    flag=true;                   
                    return;
                 }
             }    
        if(!flag){
               ImageIcon imagen =createImageIcon("resources/question.png");
                this.lbl_icono1.setIcon(imagen);
                this.lbl_message.setText("First Select a Cube");  
                 manager.getStatusB().setText("First Select a Cube");
        }
    }//GEN-LAST:event_btn_opencubeActionPerformed

    private void btn_delActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_delActionPerformed
        // TODO add your handling code here:         
          int j=this.tbl_cubeinfo.getSelectedRow();        
        if(j!=-1){
               if(username.equalsIgnoreCase(model.getValueAt(j, 1).toString()))
               {   JFrame mainFrame = MainApp.getApplication().getMainFrame();
                   ExitAlert demoDialogo4 = new ExitAlert(mainFrame,true,0,model.getValueAt(j, 0).toString());
                    demoDialogo4.setLocationRelativeTo(mainFrame);
                     MainApp.getApplication().show(demoDialogo4);         
                     if(demoDialogo4.getReturnStatus()==1)
                        deletecube();
               } else{
                   imagen =createImageIcon("resources/Error.png");
                   this.lbl_icono1.setIcon(imagen);
                   this.lbl_message.setText("Only Owner can delete the Cube");           
             
             }
        }
    }//GEN-LAST:event_btn_delActionPerformed

    private void btn_updateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_updateActionPerformed
        // TODO add your handling code here:
        
        this.lbl_message.setText("");
             this.lbl_icono1.setIcon(null);
           listcubes();
    }//GEN-LAST:event_btn_updateActionPerformed

    private void cbx_typeCubeItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_cbx_typeCubeItemStateChanged
        // TODO add your handling code here:
        this.lbl_message.setText("");
         this.lbl_icono1.setIcon(null);
          listcubes();
    }//GEN-LAST:event_cbx_typeCubeItemStateChanged
    
      private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = MainApp.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btn_del;
    private javax.swing.JButton btn_opencube;
    private javax.swing.JButton btn_update;
    private javax.swing.JComboBox cbx_typeCube;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel lbl_icono;
    private javax.swing.JLabel lbl_icono1;
    private javax.swing.JLabel lbl_message;
    private javax.swing.JTable tbl_cubeinfo;
    // End of variables declaration//GEN-END:variables
    
}
