/*
 * DiceCube.java
 *
 * Created on 12 de enero de 2009, 23:08
 */

package WorkSpace.Dice;

import Core.ManagerCube.Manager;
import WorkSpace.Dice.CheckNode;
import Core.main.Core;
import java.util.*;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeSelectionModel;
import org.olap4j.metadata.*;

/**
 *
 * @author  Alexander
 */
public class DiceCube extends javax.swing.JPanel {
    public  Object[] arbolDice;
    Core core;
    private JTree tree;
    Vector elemetosdice,measures;
    Manager manager;
    boolean band=true;
    
    /** Creates new form DiceCube */  

    public DiceCube(Manager manager, Object[] arbolDice) {
      initComponents();       
      this.arbolDice=arbolDice;        
      this.core=manager.getCore();        
      this.manager=manager; 
      funcionCreadora(arbolDice); 
      tree.setCellRenderer(new CheckRenderer());
      tree.getSelectionModel().setSelectionMode(
      TreeSelectionModel.SINGLE_TREE_SELECTION
    );
    tree.putClientProperty("JTree.lineStyle", "Angled");
    tree.addMouseListener(new NodeSelectionListener(tree));
    deleteDimensions();
    this.jScrollPane1.setViewportView(tree);
    }
  
   public void funcionCreadora(Object[] hierarchy){                
        CheckNode root = processHierarchy(hierarchy);
        tree = new JTree(root);                      
    }
   
    private void deleteDimensions() {
       DefaultTreeModel modelo =(DefaultTreeModel)tree.getModel();
       CheckNode query=(CheckNode)modelo.getRoot();
       int j=query.getChildCount();
       for(int i=0;i<j;i++)
       { 
           if(i==0&&band==true)
           { band=false;
             query.remove(i);
              i=-1;
              j--;
           }else{
                   if(existe((CheckNode)query.getChildAt(i)))
                   { query.remove(i);  
                       j--;
                       i--;
                   }
           }
       }
       tree.updateUI();
    }

    private boolean existe(CheckNode nodo) {
        boolean band=false;
        Vector rows=manager.getCore().getVectorHierarchiesCols();
        Vector cols=manager.getCore().getVectorHierarchiesRows();
        for(int i=0;i<rows.size();i++)
        {          
          if(nodo.getDimension().getName().equalsIgnoreCase(((Hierarchy)rows.get(i)).getDimension().getName()))
          {      band=true;
                 break;
          }

        }
        for(int i=0;i<cols.size();i++)
        {
          if(nodo.getDimension().getName().equalsIgnoreCase(((Hierarchy)cols.get(i)).getDimension().getName()))
          {      band=true;
                 break;
          }

        }
        return band;
    }
 
    private CheckNode processHierarchy(Object[] hierarchy) {     
         CheckNode node = new CheckNode(hierarchy[0]);
          CheckNode child;          
        for(int i=1; i<hierarchy.length; i++) {
            Object nodeSpecifier = hierarchy[i];
            if (nodeSpecifier instanceof Object[])  // Ie node with children
                child = processHierarchy((Object[])nodeSpecifier);
            else{
                child = new CheckNode(nodeSpecifier); // Ie Leaf                
            }
            node.add(child);       
        }
        return(node);
    } 
   
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btn_aplicar = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jLabel1 = new javax.swing.JLabel();

        setName("Form"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(WorkSpace.MainApp.class).getContext().getResourceMap(DiceCube.class);
        btn_aplicar.setText(resourceMap.getString("btn_aplicar.text")); // NOI18N
        btn_aplicar.setName("btn_aplicar"); // NOI18N
        btn_aplicar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_aplicarActionPerformed(evt);
            }
        });

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        jLabel1.setIcon(resourceMap.getIcon("jLabel1.icon")); // NOI18N
        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 312, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(96, 96, 96)
                        .addComponent(jLabel1)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(140, Short.MAX_VALUE)
                .addComponent(btn_aplicar)
                .addGap(133, 133, 133))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 522, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btn_aplicar)
                .addGap(89, 89, 89)
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 167, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(84, 84, 84))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btn_aplicarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_aplicarActionPerformed
        // TODO add your handling code here:
        elemetosdice=new Vector();
        selectionR((CheckNode)this.tree.getModel().getRoot());
        core.dice(elemetosdice);
        manager.printAll();
        
    }//GEN-LAST:event_btn_aplicarActionPerformed
    
    private void selectionR(CheckNode nodep) {        
        CheckNode child;         
        for(int i=0; i<nodep.getChildCount();i++) {
            child =(CheckNode) nodep.getChildAt(i);       
            if(child.isSelected())
            { 
                elemetosdice.add(child.getMember());             
            }
            else{
                    if (child.getChildCount()>0)  // Ie node with children
                        selectionR(child);
                    else{
                        if(child.isSelected())
                        {   
                            elemetosdice.add(child.getMember());                            
                        }
                    }
            }        
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btn_aplicar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables

  
    
}
