/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package WorkSpace.Navigator;
import WorkSpace.MainApp;
import java.awt.Component;
import javax.swing.ImageIcon;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
/**
 *
 * @author Alexander
 */
public class CubeCellRenderer  extends DefaultTreeCellRenderer{
		public CubeCellRenderer() {
    		super();
    	}
    @Override
        public Component getTreeCellRendererComponent(JTree tree, Object value,
                boolean isSelected, boolean expanded,
                boolean leaf, int row, boolean hasFocus) {
             ImageIcon cube = createImageIcon("resources/rubik.jpg"); 
             ImageIcon dimension = createImageIcon("resources/dimension.jpg"); 
             ImageIcon member = createImageIcon("resources/Member.png"); 
            
            String  stringValue = tree.convertValueToText(value, isSelected,
                    expanded, leaf, row, hasFocus);
               	this.hasFocus = hasFocus;
        	setText(stringValue);
        	if(isSelected)
        	    setForeground(getTextSelectionColor());
        	else
        	    setForeground(getTextNonSelectionColor());
        	
        	if (!tree.isEnabled()) {
        	    setEnabled(false);
        	}
        	else {
        	    setEnabled(true);
        	}
	         switch(((DefaultMutableTreeNode)value).getLevel()){
    		case 0:
                    setIcon(cube);
                    break;
    		case 1:
                    setIcon(cube);
                    break;
    		case 2:
                        setIcon(dimension);
                        break;
    		case 3:
                        setIcon(member);
                        break;
	        }
              setComponentOrientation(tree.getComponentOrientation());        
        	selected = isSelected;

        	return this;
            }
    private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = MainApp.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }
}