/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package WorkSpace.Navigator;

/**
 *
 * @author Alexander
 */
import javax.swing.tree.DefaultMutableTreeNode; 
import java.awt.datatransfer.Transferable; 
import java.awt.datatransfer.DataFlavor; 
import java.awt.datatransfer.UnsupportedFlavorException; 
 
public class NodesTransferable implements Transferable { 
 
  DefaultMutableTreeNode[] nodes; 
  private DataFlavor[] flavors; 
  public static String NODES_MIME_TYPE =  
               DataFlavor.javaJVMLocalObjectMimeType +  
               ";class=javax.swing.tree.DefaultMutableTreeNode"; 
 
  public NodesTransferable(DefaultMutableTreeNode[] nodes) { 
 
    DataFlavor nodesFlavor = null; 
    try { 
      nodesFlavor = new DataFlavor(NODES_MIME_TYPE); 
    } catch (ClassNotFoundException e) { 
 
    } 
    flavors = new DataFlavor[2]; 
    flavors[0] = DataFlavor.stringFlavor; 
    flavors[1] = nodesFlavor; 
    this.nodes = nodes; 
  } 
 
  public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException { 
    if (!isDataFlavorSupported(flavor)) 
      throw new UnsupportedFlavorException(flavor); 
    return nodes; 
  } 
 
  public DataFlavor[] getTransferDataFlavors() { 
    return flavors.clone(); 
  } 
 
  public boolean isDataFlavorSupported(DataFlavor flavor) { 
    for (DataFlavor f : flavors) { 
      if (flavor.equals(f)) { 
        return true; 
      } 
    } 
    return false; 
  } 
} 
