package misc.swing.comboColor;



import java.awt.Color;
import java.util.Iterator;
import java.util.SortedMap;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;

public class ComboPreparer {
	private JComboBox combo;

	private ComboPreparer(JComboBox combo) {
		super();
		this.combo=combo;
	}
	public static ComboHandle build(JComboBox combo){
		return new ComboPreparer(combo).build();
	}
	public ComboHandle build() {
		SortedMap<String, Color> map=ColorsMap.build();
		ComboHandle controller=new ComboHandle(combo, map);
		DefaultComboBoxModel cm=new DefaultComboBoxModel();
		combo.setModel(cm);
		Iterator<String> it=map.keySet().iterator();
		while(it.hasNext()){
			cm.addElement(it.next());
		}
		combo.addActionListener(controller.getActionListener());
		combo.setRenderer(new Renderer(map, controller));
		return controller;
	}
	
}
