package misc.swing.comboColor;



import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class SelectedColorChangeSupport {
	private List<ActionListener> list;

	public SelectedColorChangeSupport() {
		super();
	}
	private List<ActionListener> getList(){
		if(list==null){
			list=new ArrayList<ActionListener>();
		}
		return list;
	}
	public void addActionListener(ActionListener l){
		getList().add(l);
	}
	public void fireSelectionChange(ActionEvent e){
		if(list!=null){
			List<ActionListener> listTmp= new ArrayList<ActionListener>(getList());
			Iterator<ActionListener> it=listTmp.iterator();
			while(it.hasNext()){
				ActionListener l=it.next();
				l.actionPerformed(e);
			}
		}
	}
	
}
