package misc.swing.combofont;

import java.awt.Font;

public interface StyleSupport {
	public static final String PLAIN="Plain"; //$NON-NLS-1$
	public static final String BOLD="Bold"; //$NON-NLS-1$
	public static final String ITALIC="Italic"; //$NON-NLS-1$
	public static final String BOLD_ITALIC="Bold Italic"; //$NON-NLS-1$

	public static final String LOCALE_PLAIN=Messages.getString("StyleName.Plain"); //$NON-NLS-1$
	public static final String LOCALE_BOLD=Messages.getString("StyleName.Bold"); //$NON-NLS-1$
	public static final String LOCALE_ITALIC=Messages.getString("StyleName.Italic"); //$NON-NLS-1$
	public static final String LOCALE_BOLD_ITALIC=Messages.getString("StyleName.BoldItalic"); //$NON-NLS-1$
	
	public static final int[] value_style = {Font.PLAIN,Font.BOLD,Font.ITALIC, Font.BOLD|Font.ITALIC};
//	public static final String[] str_style = {PLAIN, BOLD, ITALIC, BOLD_ITALIC};
	public static final String[] str_locale_style = {LOCALE_PLAIN, LOCALE_BOLD, LOCALE_ITALIC, LOCALE_BOLD_ITALIC};
	public static final String[] str_size  = {"8", "10","11","12","13","14","15","16", "18","20","24"};
//	public static final String[] str_size  = {"8", "10","11","12","13","14","15","16"
//		, "18", "20", "22","24" ,"26" ,"28" ,"36" ,"48" ,"72"};
}
