package misc.swing.table;



import javax.swing.table.AbstractTableModel;


public class ArrayTableModel extends AbstractTableModel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected Object[][] data=new Object[0][0];
	
	
	public ArrayTableModel() {
		super();
	}
	public ArrayTableModel(int rows, int columns) {
		super();
		setSize(rows, columns);
	}

	public int getColumnCount() {
		if(data!=null && data.length>0){
			return data[0].length;
		}
		return 0;
	}

	public int getRowCount() {
		if(data!=null && data.length>0){
			return data.length;
		}
		return 0;
	}

	@Override
	public void setValueAt(Object value, int rowIndex, int columnIndex) {
		data[rowIndex][columnIndex]=value;
	}
	public Object getValueAt(int rowIndex, int columnIndex) {
		return data[rowIndex][columnIndex];
	}
	public void setSize(int rows, int columns) {
		data = new Object[rows][columns];
	}

}
