package misc.swing.table;



public class CellPosition {
	int row;
	int col;
	
	public static final CellPosition EMPTY_CELL_POSITION
			= new CellPosition(-1, -1);
	

	/**
	 * @param row
	 * @param col
	 */
	public CellPosition(int row, int col) {
		super();
		this.row = row;
		this.col = col;
	}


	/**
	 * @return Returns the row index.
	 */
	public int getRow() {
		return row;
	}


	/**
	 * @return Returns the col index.
	 */
	public int getCol() {
		return col;
	}
	
	public boolean isEmpty(){
		return (row==-1 || col==-1);
	}
}
