package misc.swing.table;



import java.util.EventListener;


/**
 * SpanModelListener defines the interface for an object that listens
 * to changes in a SpanModel.
 *
 */
public interface SpanModelListener extends EventListener{
    /**
     * This notification tells listeners the exact span range
     * of cells, rows, or columns that changed.
     */
    public void spanChanged(SpanModelEvent e);

}
