package misc.swing.table.settings;



import java.io.File;

import javax.swing.filechooser.FileFilter;
import misc.util.JDomUtil;


public class StylesFilter extends FileFilter{
	private final String STYLES_FILE="Styles File";
    public boolean accept(File f) {
        if ( f!=null){
            if (f.isDirectory()){
                return true;
            }else{
                try{
                   JDomUtil.read(f,TableStylesXML.TABLE_STYLES);
                   return true;
                }catch(Exception e){
                    return false;
                }
            }
        }
        return false;
    }
    public String getDescription() {
        return STYLES_FILE;
    }
}//End class StylesFilter
