package misc.swing.table.settings;



import java.util.Iterator;

import org.jdom.Element;

public class StylesXML {
	public static final String KEY_STYLES="Styles";

	
	public static Styles build(Element eStyles){
		if(eStyles!=null ){
			Styles styles=new Styles();
			if(KEY_STYLES.equals(eStyles.getName()) ){
				Iterator<?> it=eStyles.getChildren(StyleXML.KEY_STYLE).iterator();
				while(it.hasNext()){
					Element eStyle=(Element) it.next();
					if(eStyle!=null){
						try {
							Style style=StyleXML.build(eStyle);
							styles.add(style);
						} catch (RuntimeException e) {
						}
					}
				}
			}
			return styles;	
		}else{
			//throw new IllegalArgumentException("eStyles is null.");
			return null;
		}
	}
	public static Element getRootElement(Styles styles){
		if(styles!=null){
			Element eStyles=new Element(KEY_STYLES);
			int size=styles.size();
			for(int i=0; i<size; i++){
				Element eStyle=StyleXML.getRootElement(styles.get(i));
				eStyles.addContent(eStyle);
			}
			return eStyles;	
		}else{
			//throw new IllegalArgumentException("styles is null.");
			return null;
		}
	}
}
