package misc.util;



import java.awt.Font;

public class FontUtil {
	
	public static String getDescriptionFont(Font font){
		String result=new String();
		String space=" "; //$NON-NLS-1$
		if(font!=null){
			result += font.getName()+ space;
			String	strStyle;
			if (font.isBold()) {
			    strStyle = font.isItalic() ? Messages.getString("FontUtil.BoldItalic") : Messages.getString("FontUtil.Bold"); //$NON-NLS-1$ //$NON-NLS-2$
			} else {
			    strStyle = font.isItalic() ? Messages.getString("FontUtil.Italic") : Messages.getString("FontUtil.Plain"); //$NON-NLS-1$ //$NON-NLS-2$
			}

			result += strStyle;
			result += ","+space+font.getSize(); //$NON-NLS-1$
		}
		return result;
	}

	public static String getStyleFont(Font font){
		String result=new String();
		if(font!=null){
			if (font.isBold()) {
				result = font.isItalic() ? Messages.getString("FontUtil.BoldItalic") : Messages.getString("FontUtil.Bold"); //$NON-NLS-1$ //$NON-NLS-2$
			} else {
				result = font.isItalic() ? Messages.getString("FontUtil.Italic") : Messages.getString("FontUtil.Plain"); //$NON-NLS-1$ //$NON-NLS-2$
			}
		}
		return result;
	}
	
}
