package misc.util;



import java.awt.Toolkit;

import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;

public class IntegerDocument extends PlainDocument {
	private static final long serialVersionUID = 1L;
	
		public void insertString(int offset, String string
				, AttributeSet attributes) throws BadLocationException{
				
				if(string==null){
					return;
				}else{
					String newValue;
					int lenght=getLength();
					if( lenght==0){
						newValue=string;
					}else{
						String currentContend=getText(0,lenght);
						StringBuffer currentBuffer=
							new StringBuffer(currentContend);
						currentBuffer.insert(offset, string);
						newValue=currentBuffer.toString();
					}
					try {
						Integer.parseInt(newValue);
						super.insertString(offset, string,attributes);
					} catch (NumberFormatException e) {
						Toolkit.getDefaultToolkit().beep();
					}
				}
		}

}
