package misc.util;



import java.awt.Toolkit;
import java.util.BitSet;

import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;

public class LeterAndDigitDocument extends PlainDocument {
	private static final long serialVersionUID = 1L;
		private BitSet valid;
		
		public void insertString(int offset, String string
				, AttributeSet attributes) throws BadLocationException{
				
				if(string==null){
					return;
				}else{
					String newValue;
					int lenght=getLength();
					if( lenght==0){
						newValue=string;
					}else{
						String currentContend=getText(0,lenght);
						StringBuffer currentBuffer=
							new StringBuffer(currentContend);
						currentBuffer.insert(offset, string);
						newValue=currentBuffer.toString();
					}
					try {
						validate(newValue);
						super.insertString(offset, string,attributes);
					} catch (Exception e) {
						Toolkit.getDefaultToolkit().beep();
					}
				}
		}
		private void validate(String s) throws Exception{
			if(s!=null){
			    valid = getValid();
				for (int i = 0; i < s.length(); i++) {
				    if(!valid.get(s.charAt(i))){
				    	 throw  new Exception("ivalid char");
				    }
				}
			}
		}
		private BitSet getValid(){
			if(valid==null){
				valid=new BitSet(256);
				for (int i = 'a'; i <= 'z'; i++) {
					valid.set(i);
				}
				for (int i = 'A'; i <= 'Z'; i++) {
					valid.set(i);
				}
				for (int i = '0'; i <= '9'; i++) {
					valid.set(i);
				}				
			}
			return valid;
		}

}
